//%SF_HEAD_BGN
//==============================================================================
//\[X́FCIconButton
//\[XFACR{^NX
//쐬NF2000/11/30
//쐬Җ  FMacBS
//l      F
//==============================================================================
//%SF_HEAD_END

#include "stdafx.h"
#include <shlobj.h>
#include "Resource.h"
#include "Comfunc.h"
#include "mblaunch.h"
#include "ExecDlg.h"
#include "BtnSetDlg.h"
#include "Msi.h"

#define	BP_PUSHBUTTON	0x00000001
#define	PBS_NORMAL		0x00000001
#define	PBS_HOT			0x00000002
#define	PBS_PRESSED		0x00000003
#define	PBS_DISABLED	0x00000004
#define	PBS_DEFAULTED	0x00000005

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIconButton

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::CIconButton
//\bhFRXgN^
//`    F  CIconButton::CIconButton(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
CIconButton::CIconButton()
{
	//Xs̏
	m_iSpin = 0 ;
	m_bState = FALSE;
	m_hIcon = NULL;
	m_hIcon_Old = NULL;

	m_iAreaMax = 0;

	m_csTitle = NULL;
	m_iItem = NULL;
	m_csFileName = NULL;
	m_csOption = NULL;
	m_iShowFlag = 0;
	m_csIconName = NULL;
	m_bIcon = NULL;
//Add v0.22
	m_phIcon = NULL;
//Add v0.22
	m_cLoadFlg = NULL;
	m_BitsPerPel = 0;

	m_lLabelID = 0;
	m_iSectionIndex = 0;

	m_bMouseOnButton = FALSE;
	m_bAlwaysTrack = FALSE;

	m_pcTheme = new CThemeHelperST;
}

int CIconButton::AllocArea( int iAreaMax )
{
	int iLoop;

	if ( iAreaMax <= 0 ) {
		return( -1 );
	}

	m_iAreaMax = iAreaMax;

	TRY {
		m_csTitle = new CString[m_iAreaMax];
		if ( m_csTitle == NULL ) {
			return( -1 );
		}
		m_iItem = new int[m_iAreaMax];
		if ( m_iItem == NULL ) {
			return( -1 );
		}
		m_csFileName = new CString[m_iAreaMax];
		if ( m_csFileName == NULL ) {
			return( -1 );
		}
		m_csOption = new CString[m_iAreaMax];
		if ( m_csOption == NULL ) {
			return( -1 );
		}
		m_iShowFlag = new int[m_iAreaMax];
		if ( m_iShowFlag == NULL ) {
			return( -1 );
		}
		m_csIconName = new CString[m_iAreaMax];
		if ( m_csIconName == NULL ) {
			return( -1 );
		}
		m_bIcon = new BOOL[m_iAreaMax];
		if ( m_bIcon == NULL ) {
			return( -1 );
		}
//Add v0.22
		m_phIcon = new HICON[m_iAreaMax];
		if ( m_phIcon == NULL ) {
			return( -1 );
		}
//Add v0.22
		m_cLoadFlg = new char[m_iAreaMax];
		if ( m_cLoadFlg == NULL ) {
			return( -1 );
		}

		//[htȌ
		for ( iLoop = 0; iLoop < m_iAreaMax; iLoop++ ) {
			m_cLoadFlg[iLoop] = 0;
//Add v0.22
			m_phIcon[iLoop] = NULL;
//Add v0.22
		}

		return( 0 );

	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::~CIconButton
//\bhFfXgN^
//`    F  CIconButton::~CIconButton(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
CIconButton::~CIconButton()
{
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		//G[
		return;
	}

	DeleteIconCache();
	if ( pApp->m_cIniInfo.loadOptionCacheIcon() != 0 ) {
		SaveIconCache();
	}

	if ( m_csTitle != NULL ) {
		delete m_pcTheme;
		m_pcTheme = NULL;
	}
	if ( m_csTitle != NULL ) {
		delete [] m_csTitle;
		m_csTitle = NULL;
	}
	if ( m_iItem != NULL ) {
		delete m_iItem;
		m_iItem = NULL;
	}
	if ( m_csFileName != NULL ) {
		delete [] m_csFileName;
		m_csFileName = NULL;
	}
	if ( m_csOption != NULL ) {
		delete [] m_csOption;
		m_csOption = NULL;
	}
	if ( m_iShowFlag != NULL ) {
		delete [] m_iShowFlag;
		m_iShowFlag = NULL;
	}
	if ( m_csIconName != NULL ) {
		delete [] m_csIconName;
		m_csIconName = NULL;
	}
	if ( m_bIcon != NULL ) {
		delete m_bIcon;
		m_bIcon = NULL;
	}
//Add v0.22
	if ( m_phIcon != NULL ) {
		int iLoop;
		for ( iLoop = 0; iLoop < m_iAreaMax; iLoop++ ) {
			if ( m_phIcon[iLoop] != NULL ) {
				::DestroyIcon( m_phIcon[iLoop] );
				m_phIcon[iLoop] = NULL;
			}
		}
		delete m_phIcon;
		m_phIcon = NULL;
	}
//Add v0.22
	if ( m_cLoadFlg != NULL ) {
		delete m_cLoadFlg;
		m_cLoadFlg = NULL;
	}
}


BEGIN_MESSAGE_MAP(CIconButton, CButton)
	//{{AFX_MSG_MAP(CIconButton)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_SETBTN, OnSetbtn)
	ON_COMMAND(ID_EXPLORER, OnExplorer)
	ON_COMMAND(ID_CLRBTN, OnClrbtn)
	ON_COMMAND(ID_CPYBTN, OnCpybtn)
	ON_COMMAND(ID_PSTBTN, OnPstbtn)
	ON_COMMAND(ID_XCHBTN, OnXchbtn)
	ON_WM_DROPFILES()
	ON_CONTROL_REFLECT(BN_CLICKED, OnClicked)
	ON_WM_MOUSEMOVE()
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
	ON_WM_KILLFOCUS()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnNeedText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIconButton bZ[W nh

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnRButtonDown
//\bhF{^̓o^\(ENbN)
//`    F  void CIconButton::OnRButtonDown(
//@@@@@@@F    [in]  UINT nFlags    :  L[
//@@@@@@@F    [in]  CPoint point   :  J[\̍W
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnRButtonDown(UINT nFlags, CPoint point) 
{
	RECT Rect;
	CMenu cMenu;
	BOOL bRet = 0;
	CMenu* pPopup;

	//|bvAbvj[̓ǂݍ
	bRet = cMenu.LoadMenu( IDR_POPUPMENU );
	if ( bRet == 0 ) {
		//j[ǂݍݎs
		return;
	}

	//|bvAbvj[̎擾
	pPopup = cMenu.GetSubMenu( 0 );
	if ( pPopup == NULL ) {
		//|bvAbv j[擾s
		return;
	}

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		//G[
		return;
	}

	if ( pApp->m_clipUse == 0 ) {
		pPopup->ModifyMenu( ID_PSTBTN, MF_BYCOMMAND | MF_GRAYED, -1, "\t" );
		pPopup->ModifyMenu( ID_XCHBTN, MF_BYCOMMAND | MF_GRAYED, -1, "ւ" );
	}

	GetWindowRect( &Rect );
	//͔͈͂{^̘gɓĂ邩H
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, Rect.left + point.x, Rect.top + point.y, this );

	CButton::OnRButtonDown(nFlags, point);
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnSetbtn
//\bhF{^̓o^ݒ(ENbNj[)
//`    F  void CIconButton::OnSetbtn(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnSetbtn() 
{
	HICON hIcon = NULL;
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	CString CButtonName;
	CBtnSetDlg btnsetDlg;
	int iRet = 0;

	TRY {
		//xID̎擾
		if ( m_lLabelID < 0 ) {
			//G[
			return;
		}

		//eEBhẼx̃|C^擾
		pCExecDlg = (CExecDlg*)GetOwner();
		if ( pCExecDlg != NULL ) {
			CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
		}
		else if ( pCExecDlg == NULL ) {
			//e޳̎擾s
			return;
		}

		if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
			return;
		}

		//t@CŐ󔒂
		m_csFileName[m_iSpin].TrimLeft();
		m_csFileName[m_iSpin].TrimRight();
		m_csIconName[m_iSpin].TrimLeft();
		m_csIconName[m_iSpin].TrimRight();

		//{^ݒ_CAOɓ]
		btnsetDlg.m_csTitle = m_csTitle[m_iSpin];
		btnsetDlg.m_iItem = m_iItem[m_iSpin];
		btnsetDlg.m_csFileName = m_csFileName[m_iSpin];
		btnsetDlg.m_csOption = m_csOption[m_iSpin];
		btnsetDlg.m_iShowFlag = m_iShowFlag[m_iSpin];
//Add v0.23
		btnsetDlg.m_bIcon = m_bIcon[m_iSpin];
//Add v0.23
		if ( m_bIcon[m_iSpin] == FALSE ) {
			AutoIconName( m_csFileName[m_iSpin], btnsetDlg.m_csIconName );
		}
		else {
			btnsetDlg.m_csIconName = m_csIconName[m_iSpin];
		}

		//ݒ_CAO̕\
		if ( btnsetDlg.DoModal() == IDOK ) {
			//ݒ{^ɓ]
			m_iItem[m_iSpin] = btnsetDlg.m_iItem;
			m_csTitle[m_iSpin] = btnsetDlg.m_csTitle;
			m_csFileName[m_iSpin] = btnsetDlg.m_csFileName;
			m_csOption[m_iSpin] = btnsetDlg.m_csOption;
			m_iShowFlag[m_iSpin] = btnsetDlg.m_iShowFlag;
			m_csIconName[m_iSpin] = btnsetDlg.m_csIconName;
			m_bIcon[m_iSpin] = btnsetDlg.m_bIcon;

			//t@CŐ󔒂
			m_csIconName[m_iSpin].TrimLeft();
			m_csIconName[m_iSpin].TrimRight();

			hIcon = LoadAutoIcon( m_csIconName[m_iSpin], m_iItem[m_iSpin] );

//Add v0.22
			if ( m_phIcon[m_iSpin] != NULL ) {
				::DestroyIcon( m_phIcon[m_iSpin] );
				m_phIcon[m_iSpin] = NULL;
			}
			m_phIcon[m_iSpin] = hIcon;
//Add v0.22

			//{^ACR̐ݒ
//			SetButtonIcon( EXEC_ICON_X, EXEC_ICON_Y, m_phIcon[m_iSpin] );
			SetIcon2( m_phIcon[m_iSpin] );

			//x̐ݒ
			if ( CStaticPtr != NULL ) {
				SetStaticText( CStaticPtr, btnsetDlg.m_csTitle );
			}

			//{^̕ۑ(ICONԍn悤ɕύX)
			iRet = SaveExeInfo( m_iSpin );
			if ( iRet < 0 ) {
				return;
			}
		}
	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnExplorer
//\bhF{^̓o^tH_J(ENbNj[)
//`    F  void CIconButton::OnExplorer(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnExplorer()
{
	HICON hIcon = NULL;
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	int iRet = 0;
	char cPathName[EXECFILEMAX];

	TRY {
		//xID̎擾
		if ( m_lLabelID < 0 ) {
			//G[
			return;
		}

		//eEBhẼx̃|C^擾
		pCExecDlg = (CExecDlg*)GetOwner();
		if ( pCExecDlg != NULL ) {
			CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
		}
		else if ( pCExecDlg == NULL ) {
			//e޳̎擾s
			return;
		}

		if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
			return;
		}

		//t@CŐ󔒂
		m_csFileName[m_iSpin].TrimLeft();
		m_csFileName[m_iSpin].TrimRight();

		//tH_𒊏o
		splitPath( cPathName, m_csFileName[m_iSpin].GetBuffer(m_csFileName[m_iSpin].GetLength()) );
		m_csFileName[m_iSpin].ReleaseBuffer();

		ExecStart( cPathName, NULL, 0 );

	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnClrbtn
//\bhF{^̓o^NA(ENbNj[)
//`    F  void CIconButton::OnClrbtn(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnClrbtn() 
{
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	int iRet = 0;
	HICON hIcon;

	//Ή郉xID擾
	if ( m_lLabelID < 0 ) {
		//G[
		return;
	}

	if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
		return;
	}

	//eEBhẼx̃|C^擾
	pCExecDlg = (CExecDlg*)GetOwner();
	if ( pCExecDlg != NULL ) {
		CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
	}
	else if ( pCExecDlg == NULL ) {
		return;
	}

	//mF_CAO̕\
	if ( MessageBox( ERR_EXEC_MSG02, ERR_EXEC_TITLE01, MB_ICONQUESTION | MB_YESNO ) == IDYES ) {
		//{^NA
		m_csTitle[m_iSpin] = "";
		m_csFileName[m_iSpin] = "";
		m_csOption[m_iSpin] = "";
		m_iShowFlag[m_iSpin] = 0;
		m_csIconName[m_iSpin] = "";
		m_iItem[m_iSpin] = 0;
		m_bIcon[m_iSpin] = FALSE;

		//ACR̃NA
		hIcon = NULL;

//Add v0.22
		if ( m_phIcon[m_iSpin] != NULL ) {
			::DestroyIcon( m_phIcon[m_iSpin] );
			m_phIcon[m_iSpin] = NULL;
		}
		m_phIcon[m_iSpin] = hIcon;
//Add v0.22

		//{^ACR̐ݒ
//		SetButtonIcon( EXEC_ICON_X, EXEC_ICON_Y, m_phIcon[m_iSpin] );
		SetIcon2( m_phIcon[m_iSpin] );

		//x̃NA
		if ( CStaticPtr != NULL ) {
			SetStaticText( CStaticPtr, CString("") );
		}

		//{^̕ۑ
		iRet = SaveExeInfo( m_iSpin );
		if ( iRet < 0 ) {
			return;
		}
	}
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::SaveExeInfo
//\bhF{^̓o^INIt@Cɕۑ
//`    F  void CIconButton::SaveExeInfo(
//@@@@@@@F    [in]  int iSpin   :   Xsԍ
//              F  )
//^[l  F0:, -1:G[
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CIconButton::SaveExeInfo( int iSpin )
{
	CString csTemp;
	int iIndex;

	TRY {
		iIndex = m_iSectionIndex;

		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return( -1 );
		}

		//^Cg̕ۑ
		pApp->m_cIniInfo.saveButtonTitle( iIndex, iSpin, m_csTitle[iSpin].GetBuffer(m_csTitle[iSpin].GetLength()) );
		m_csTitle[iSpin].ReleaseBuffer();

		//EXEt@C̕ۑ
		pApp->m_cIniInfo.saveButtonFileName( iIndex, iSpin, m_csFileName[iSpin].GetBuffer(m_csFileName[iSpin].GetLength()) );
		m_csFileName[iSpin].ReleaseBuffer();

		//NIvV̕ۑ
		saveButtonOption( iIndex, iSpin, m_csOption[iSpin].GetBuffer(m_csOption[iSpin].GetLength()) );
		m_csOption[iSpin].ReleaseBuffer();

		//\tO̕ۑ
		saveButtonShowFlag( iIndex, iSpin, m_iShowFlag[iSpin] );

		//ACRLtO̕ۑ
		if ( m_bIcon[iSpin] == FALSE ) {
			saveButtonIconFlag( iIndex, iSpin, "0" );
		}
		else {
			saveButtonIconFlag( iIndex, iSpin, "1" );
		}

		//ACRt@C̕ۑ
		saveButtonIconName( iIndex, iSpin, m_csIconName[iSpin].GetBuffer(m_csIconName[iSpin].GetLength()) );
		m_csIconName[iSpin].ReleaseBuffer();

		//ACRԍ̕ۑ
		csTemp.Format( "%d", m_iItem[iSpin] );
		saveButtonIconNum( iIndex, iSpin, csTemp.GetBuffer(csTemp.GetLength()) );
		csTemp.ReleaseBuffer();

//Add Start v0.29
		//j[̊Yڂ̃ACRLbV폜
		if ( pApp->m_pccMainFrame != NULL ) {
			if ( pApp->m_pccMainFrame->m_pphIcon != NULL ) {
				if ( pApp->m_pccMainFrame->m_pphIcon[iSpin*EXEC_BUTTON_MAX+iIndex] != NULL ) {
					::DestroyIcon( *(pApp->m_pccMainFrame->m_pphIcon[iSpin*EXEC_BUTTON_MAX+iIndex]) );
					delete pApp->m_pccMainFrame->m_pphIcon[iSpin*EXEC_BUTTON_MAX+iIndex];
					pApp->m_pccMainFrame->m_pphIcon[iSpin*EXEC_BUTTON_MAX+iIndex] = NULL;
				}
			}
//			if ( pApp->m_pccMainFrame->m_ppcsTitle != NULL ) {
//				if ( pApp->m_pccMainFrame->m_ppcsTitle[iSpin*EXEC_BUTTON_MAX+iIndex] != NULL ) {
//					delete pApp->m_pccMainFrame->m_ppcsTitle[iSpin*EXEC_BUTTON_MAX+iIndex];
//					pApp->m_pccMainFrame->m_ppcsTitle[iSpin*EXEC_BUTTON_MAX+iIndex] = NULL;
//				}
//			}
		}
//Add End   v0.29
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH

	return( 0 );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::LoadExeInfo
//\bhF{^̓o^INIt@CĂяo
//`    F  int CIconButton::LoadExeInfo(
//@@@@@@@F    [in]  int iSpin   :   Xsԍ
//              F  )
//^[l  F 0:EXEt@C̓o^Ă
//@@@@@@@F 1:EXEt@C̓o^sĂȂ
//@@@@@@@F-1:G[
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CIconButton::LoadExeInfo( int iSpin )
{
	CString CSectionName;
	int iLen = 0;
	char cTemp[EXEC_TEMP_MAX];
	DWORD ProfileLen = 0;
	int i = 0;
	int iExecSetFLG = 0;
	int iRet = 0;
	int iShowFlag;
	char* pcTemp;

	pcTemp = NULL;

	TRY {
		//Xsԍ͈̔̓`FbN
		if ( iSpin < 0 || iSpin >= m_iAreaMax ) {
			return( -1 );
		}

		if ( m_cLoadFlg[iSpin] == 1 ) {
			//Ƀ[hςȂ炻̂܂܏I
			return( 0 );
		}
		else {
			//[htO𗧂Ă
			m_cLoadFlg[iSpin] = 1;
		}

		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return( -1 );
		}

		//t@C̎擾
		if ( pApp->m_cIniInfo.loadButtonFileName(m_iSectionIndex, iSpin, cTemp) < 0 ) {
			m_csFileName[iSpin] = "";

			//t@Cw肳ĂȂΖo^Ƃ݂Ȃ
			m_csTitle[iSpin] = "";
			m_csOption[iSpin] = "";
			m_iShowFlag[iSpin] = 0;
			m_csIconName[iSpin] = "";
			m_iItem[iSpin] = 0;
			m_bIcon[iSpin] = FALSE;

			//o^ĂȂ
			iExecSetFLG = iSpin + 1;

			//t@Cw肳ĂȂΖo^Ƃ݂Ȃ
			return( 0 );
		}
		else {
			m_csFileName[iSpin] = cTemp;
		}

		//^Cg̎擾
		if ( pApp->m_cIniInfo.loadButtonTitle(m_iSectionIndex, iSpin, cTemp) < 0 ) {
			m_csTitle[iSpin] = "";
		}
		else {
			m_csTitle[iSpin] = cTemp;
		}

		//NIvV̎擾
		if ( loadButtonOption(m_iSectionIndex, iSpin, cTemp) < 0 ) {
			m_csOption[iSpin] = "";
		}
		else {
			m_csOption[iSpin] = cTemp;
		}

		//\tO̎擾
		if ( loadButtonShowFlag(m_iSectionIndex, iSpin, &iShowFlag) < 0 ) {
			m_iShowFlag[iSpin] = 0;
		}
		else {
			m_iShowFlag[iSpin] = iShowFlag;
		}

		//ACRtO̎擾
		if ( loadButtonIconFlag(m_iSectionIndex, iSpin, cTemp) < 0 ) {
			m_bIcon[iSpin] = FALSE;
		}
		else {
			if ( cTemp[0] == '1' ) {
				m_bIcon[iSpin] = TRUE;
			}
			else {
				m_bIcon[iSpin] = FALSE;
			}
		}

		//ACRt@C̎擾
		if ( loadButtonIconName(m_iSectionIndex, iSpin, cTemp) < 0 ) {
			m_csIconName[iSpin] = "";
		}
		else {
			m_csIconName[iSpin] = cTemp;
		}

		//ACRԍ̎擾
		if ( loadButtonIconNum(m_iSectionIndex, iSpin, cTemp) < 0 ) {
			m_iItem[iSpin] = 0;
		}
		else {
			m_iItem[iSpin] = atoi( cTemp );
		}

		if ( pcTemp != NULL ) {
			CSectionName.ReleaseBuffer();
			pcTemp = NULL;
		}

	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH

	return( iExecSetFLG );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::PreSubclassWindow
//\bhF{^A^b`̏
//`    F  void CIconButton::PreSubclassWindow(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::PreSubclassWindow() 
{
	HICON hIcon = NULL;
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	int iRet = 0;
	char cTm[EXECTMP10];

	memset( cTm, 0x00, sizeof(cTm) );

//Add Start v0.34
	DragAcceptFiles( TRUE );
//Add End   v0.34

	//{^^Cg擾
	CString csButtonName;
	GetWindowText( csButtonName );
	m_iSectionIndex = GetSectionIndex( csButtonName );
	SetWindowText( "" );

	//Ή郉xID擾
	GetLabelId( &m_lLabelID );
	if ( m_lLabelID < 0 ) {
		//G[
		return;
	}

	//eEBhẼx̃|C^擾
	pCExecDlg = (CExecDlg*)GetOwner();
	if ( pCExecDlg != NULL ) {
		CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
	}
	else if ( pCExecDlg == NULL ) {
		//G[
		return;
	}

//Add Start v0.56
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		//G[
		return;
	}
//Add End   v0.56

	//Xs{^̓ǂݍ
	if ( loadOptionFirstPageDisp() != 0 ) {
		m_iSpin = 1;
	}
	else {
		m_iSpin = pApp->m_cIniInfo.loadButtonPageNum( m_iSectionIndex );
		if ( m_iSpin == -1 ) {
			pCExecDlg->SpinLoad( cTm );
			m_iSpin = atoi( cTm );
		}
		else {
			//_CAO^Cg̕ύX
			pCExecDlg->m_blCustomPage = TRUE;
		}
	}

	if ( m_iSpin > m_iAreaMax ) {
		m_iSpin = m_iAreaMax;
	}
	else if ( m_iSpin <= 0 && m_iAreaMax > 0 ) {
		m_iSpin = 1;
	}

	m_iSpin = m_iSpin - 1;

	//INIt@C̃{^̎擾
	iRet = LoadExeInfo( m_iSpin );
	if ( iRet < 0 ) {
		//G[
		return;
	}

	//Xs͈͂𒴂ĂȂ
	if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
		//G[
		return;
	}

	//t@CŐ󔒂
	m_csIconName[m_iSpin].TrimLeft();
	m_csIconName[m_iSpin].TrimRight();

	if ( m_csIconName[m_iSpin].GetLength() > 0 ) {
		hIcon = LoadAutoIcon( m_csIconName[m_iSpin], m_iItem[m_iSpin] );
	}
	else {
		//ACR̃NA
		hIcon = NULL;
	}

//Add v0.31
	//ʐF̕ۑ
	CDC *pDC = GetDC();
	if ( pDC != NULL ) {
		m_BitsPerPel = pDC->GetDeviceCaps( BITSPIXEL );
		ReleaseDC( pDC );
	}
//Add v0.31

//Add v0.22
	if ( m_phIcon[m_iSpin] != NULL ) {
		::DestroyIcon( m_phIcon[m_iSpin] );
		m_phIcon[m_iSpin] = NULL;
	}
	m_phIcon[m_iSpin] = hIcon;
//Add v0.22

	if ( pApp->m_cIniInfo.loadOptionCacheIcon() != 0 ) {
		LoadIconCache();
	}

	//{^ACR̐ݒ
//	SetButtonIcon( EXEC_ICON_X, EXEC_ICON_Y, m_phIcon[m_iSpin] );
	SetIcon2( m_phIcon[m_iSpin] );

	//x̐ݒ
	if ( CStaticPtr != NULL ) {
		SetStaticText( CStaticPtr, m_csTitle[m_iSpin] );
	}

	CButton::PreSubclassWindow();
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::ToggleChange
//\bhFgO؂ւꂽꍇAACR̍Đݒs
//`    F  void CIconButton::ToggleChange(
//@@@@@@@F    [in]  int iSpin   :   Xsԍ
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::ToggleChange( int iSpin )
{
	HICON hIcon = NULL;
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	int iSpinOld;

	//Ή郉xID擾
	if ( m_lLabelID < 0 ) {
		//G[
		return;
	}

	//eEBhẼx̃|C^擾
	pCExecDlg = (CExecDlg*)GetOwner();
	if ( pCExecDlg != NULL ) {
		CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
	}
	else if ( pCExecDlg != NULL ) {
		return;
	}

	if ( iSpin < 0 || iSpin > m_iAreaMax - 1 ) {
		return;
	}
	else {
		iSpinOld = m_iSpin;
		m_iSpin = iSpin;
	}

	//INIt@C̃{^̎擾
	if ( LoadExeInfo( m_iSpin ) < 0 ) {
		return;
	}

	//t@CŐ󔒂
	m_csIconName[m_iSpin].TrimLeft();
	m_csIconName[m_iSpin].TrimRight();

//Add v0.31
	//ʐFXVĂ΃LbVNA
	CDC *pDC = GetDC();
	if ( pDC != NULL ) {
		int iBitsPerPel = pDC->GetDeviceCaps( BITSPIXEL );
		if ( m_BitsPerPel != iBitsPerPel ) {
			//SẴACRUNA
			if ( m_phIcon != NULL ) {
				int iLoop;
				for ( iLoop = 0; iLoop < m_iAreaMax; iLoop++ ) {
					if ( m_phIcon[iLoop] != NULL ) {
						::DestroyIcon( m_phIcon[iLoop] );
						m_phIcon[iLoop] = NULL;
					}
				}
			}
		}
		ReleaseDC( pDC );
		//ʐF̍XV
		m_BitsPerPel = iBitsPerPel;
	}
//Add v0.31

	if ( m_phIcon[m_iSpin] == NULL ) {

		if ( m_csIconName[m_iSpin].GetLength() > 0 ) {
			hIcon = LoadAutoIcon( m_csIconName[m_iSpin], m_iItem[m_iSpin] );
		}
		else {
			hIcon = NULL;
		}

		//ɃLbVɓĂ΂폜
		if ( m_phIcon[m_iSpin] != NULL ) {
			::DestroyIcon( m_phIcon[m_iSpin] );
			m_phIcon[m_iSpin] = NULL;
		}

		m_phIcon[m_iSpin] = hIcon;
	}

	//{^ACR̐ݒ
//	SetButtonIcon( EXEC_ICON_X, EXEC_ICON_Y, m_phIcon[m_iSpin] );
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionNoAnime() == 0 ) {
			if ( m_iSpin-iSpinOld == m_iAreaMax - 1 ) {
				SetIcon3( m_phIcon[m_iSpin], -1 );
			}
			else if ( m_iSpin-iSpinOld == 1 - m_iAreaMax ) {
				SetIcon3( m_phIcon[m_iSpin], 1 );
			}
			else if ( m_iSpin-iSpinOld > 0 ) {
				SetIcon3( m_phIcon[m_iSpin], 1 );
			}
			else if ( m_iSpin-iSpinOld < 0 ) {
				SetIcon3( m_phIcon[m_iSpin], -1 );
			}
			else {
				SetIcon2( m_phIcon[m_iSpin] );
			}
		}
		else {
			SetIcon2( m_phIcon[m_iSpin] );
		}
	}
	else {
		SetIcon2( m_phIcon[m_iSpin] );
	}

	//x̐ݒ
	if ( CStaticPtr != NULL ) {
		SetStaticText( CStaticPtr, m_csTitle[m_iSpin] );
	}

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::GetLabelId
//\bhF{^ɑΉ郉xID擾
//`    F  void CIconButton::GetLabelId(
//@@@@@@@F    [out] long* plID   :  {^ɑΉ郉xhc
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F{^\[X𖼑OŌĂB\[XύX͗v
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::GetLabelId( long* plID )
{
	int iIndex;

	iIndex = m_iSectionIndex;

//{^ύXC
	//Ή郉xID擾
	switch ( iIndex ) {
	  case 0:
		*plID = IDC_TITLE1;
		break;
	  case 1:
		*plID = IDC_TITLE2;
		break;
	  case 2:
		*plID = IDC_TITLE3;
		break;
	  case 3:
		*plID = IDC_TITLE4;
		break;
	  case 4:
		*plID = IDC_TITLE5;
		break;
	  case 5:
		*plID = IDC_TITLE6;
		break;
	  case 6:
		*plID = IDC_TITLE7;
		break;
	  case 7:
		*plID = IDC_TITLE8;
		break;
	  case 8:
		*plID = IDC_TITLE9;
		break;
	  case 9:
		*plID = IDC_TITLEA;
		break;
	  case 10:
		*plID = IDC_TITLEB;
		break;
	  case 11:
		*plID = IDC_TITLEC;
		break;
	  case 12:
		*plID = IDC_TITLED;
		break;
	  case 13:
		*plID = IDC_TITLEE;
		break;
	  case 14:
		*plID = IDC_TITLEF;
		break;
	  case 15:
		*plID = IDC_TITLEG;
		break;
	  case 16:
		*plID = IDC_TITLEH;
		break;
	  case 17:
		*plID = IDC_TITLEI;
		break;
	  case 18:
		*plID = IDC_TITLEJ;
		break;
	  case 19:
		*plID = IDC_TITLEK;
		break;
	  case 20:
		*plID = IDC_TITLEL;
		break;
	  case 21:
		*plID = IDC_TITLEM;
		break;
	  case 22:
		*plID = IDC_TITLEN;
		break;
	  case 23:
		*plID = IDC_TITLEO;
		break;
	  case 24:
		*plID = IDC_TITLEP;
		break;
	  case 25:
		*plID = IDC_TITLEQ;
		break;
	  case 26:
		*plID = IDC_TITLER;
		break;
	  case 27:
		*plID = IDC_TITLES;
		break;
	  case 28:
		*plID = IDC_TITLET;
		break;
	  case 29:
		*plID = IDC_TITLEU;
		break;
	  case 30:
		*plID = IDC_TITLEV;
		break;
	  case 31:
		*plID = IDC_TITLEW;
		break;
	  case 32:
		*plID = IDC_TITLEX;
		break;
	  case 33:
		*plID = IDC_TITLEY;
		break;
	  case 34:
		*plID = IDC_TITLEZ;
		break;
	  default:
		*plID = -1;
		break;
	}

	return ;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::GetExeFileInfo
//\bhFACRɐݒ肳Ăst@C̎擾
//`    F  void CIconButton::GetExeFileInfo(
//@@@@@@@F    [out] char* pcRunFileName      :  st@C
//@@@@@@@F    [out] char* pcRunOption        :  sIvV
//@@@@@@@F    [out] int*  piRunShow          :  \tO
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CIconButton::GetExeFileInfo( char* pcRunFileName, char* pcRunOption, int* piRunShow )
{
	CString csTemp;

	if ( pcRunFileName == NULL || pcRunOption == NULL || piRunShow == NULL ) {
		//G[
		return ( -1 );
	}

	TRY {
		//t@C̎擾
		csTemp = m_csFileName[m_iSpin];
		if ( csTemp.GetLength() <= 0 ) {
			//t@COȂG[
			return ( -1 );
		}
		else {
			strcpy( pcRunFileName, _T(csTemp.GetBuffer(csTemp.GetLength())) );
			csTemp.ReleaseBuffer();
		}

		//IvV̎擾
		csTemp = m_csOption[m_iSpin];
		if ( csTemp.GetLength() <= 0 ) {
			strcpy( pcRunOption, "" );
		}
		else {
			strcpy( pcRunOption, _T(csTemp.GetBuffer(csTemp.GetLength())) );
			csTemp.ReleaseBuffer();
		}

		//\tO̎擾
		*piRunShow = m_iShowFlag[m_iSpin];

		return ( 0 );
	}
	CATCH( CMemoryException, e ) {
		return ( -1 );
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnClicked
//\bhF{^̏
//`    F  void CIconButton::OnClicked(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnClicked() 
{
	RunIcon( CString("") );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnCpybtn
//\bhF{^̓o^Rs[(ENbNj[)
//`    F  void CIconButton::OnCpybtn(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnCpybtn() 
{
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;

	TRY {
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			//G[
			return ;
		}

		//xID̎擾
		if ( m_lLabelID < 0 ) {
			//G[
			return;
		}

		//eEBhẼx̃|C^擾
		pCExecDlg = (CExecDlg*)GetOwner();
		if ( pCExecDlg != NULL ) {
			CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
		}
		else if ( pCExecDlg == NULL ) {
			//e޳̎擾s
			return;
		}

		if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
			return;
		}

		//t@CŐ󔒂
		m_csFileName[m_iSpin].TrimLeft();
		m_csFileName[m_iSpin].TrimRight();
		m_csIconName[m_iSpin].TrimLeft();
		m_csIconName[m_iSpin].TrimRight();

		//{^Nbv̈ɋL
		pApp->m_clipTitle     = m_csTitle[m_iSpin];
		pApp->m_clipItem      = m_iItem[m_iSpin];
		pApp->m_clipFileName  = m_csFileName[m_iSpin];
		pApp->m_clipOption    = m_csOption[m_iSpin];
		pApp->m_clipShowFlag  = m_iShowFlag[m_iSpin];
		pApp->m_clipIcon      = m_bIcon[m_iSpin];
		pApp->m_clipPageNum   = m_iSpin;
		pApp->m_clipButtonNum = m_iSectionIndex;

		if ( m_bIcon[m_iSpin] == FALSE ) {
			AutoIconName( m_csFileName[m_iSpin], pApp->m_clipIconName );
		}
		else {
			pApp->m_clipIconName = m_csIconName[m_iSpin];
		}

		//\tLtO𗧂Ă
		pApp->m_clipUse = 1;

		return;
	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnPstbtn
//\bhF{^̓o^\t(ENbNj[)
//`    F  void CIconButton::OnPstbtn(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnPstbtn() 
{
	HICON hIcon = NULL;
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	int iRet = 0;

	TRY {
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			//G[
			return;
		}

		//xID̎擾
		if ( m_lLabelID < 0 ) {
			//G[
			return;
		}

		//eEBhẼx̃|C^擾
		pCExecDlg = (CExecDlg*)GetOwner();
		if ( pCExecDlg != NULL ) {
			CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
		}
		else if ( pCExecDlg == NULL ) {
			//e޳̎擾s
			return;
		}

		if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
			return;
		}

		//\tLtO`FbN
		if ( pApp->m_clipUse != 1 ) {
			return;
		}

		//Nbv{^ɐݒ
		m_csTitle[m_iSpin]    = pApp->m_clipTitle;
		m_iItem[m_iSpin]      = pApp->m_clipItem;
		m_csFileName[m_iSpin] = pApp->m_clipFileName;
		m_csOption[m_iSpin]   = pApp->m_clipOption;
		m_iShowFlag[m_iSpin]  = pApp->m_clipShowFlag;
		m_csIconName[m_iSpin] = pApp->m_clipIconName;
		m_bIcon[m_iSpin]      = pApp->m_clipIcon;

		//t@CŐ󔒂
		m_csIconName[m_iSpin].TrimLeft();
		m_csIconName[m_iSpin].TrimRight();

		hIcon = LoadAutoIcon( m_csIconName[m_iSpin], m_iItem[m_iSpin] );

//Add v0.22
		if ( m_phIcon[m_iSpin] != NULL ) {
			::DestroyIcon( m_phIcon[m_iSpin] );
			m_phIcon[m_iSpin] = NULL;
		}
		m_phIcon[m_iSpin] = hIcon;
//Add v0.22

		//{^ACR̐ݒ
//		SetButtonIcon( EXEC_ICON_X, EXEC_ICON_Y, m_phIcon[m_iSpin] );
		SetIcon2( m_phIcon[m_iSpin] );

		//x̐ݒ
		if ( CStaticPtr != NULL ) {
			SetStaticText( CStaticPtr, m_csTitle[m_iSpin] );
		}

		//{^̕ۑ(ICONԍn悤ɕύX)
		iRet = SaveExeInfo( m_iSpin );
		if ( iRet < 0 ) {
			return;
		}

		return;
	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnXchbtn
//\bhF{^̓o^ւ(ENbNj[)
//`    F  void CIconButton::OnXchbtn(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2003/07/27
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIconButton::OnXchbtn() 
{
	HICON hIcon = NULL;
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	int iRet = 0;
	CIconButton* pcsXcgIconBtn = NULL;
	CString csTitle;
	int iItem;
	CString csFileName;
	CString csOption;
	int iShowFlag;
	CString csIconName;
	BOOL bIcon;

	TRY {
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			//G[
			return;
		}

		//xID̎擾
		if ( m_lLabelID < 0 ) {
			//G[
			return;
		}

		//eEBhẼx̃|C^擾
		pCExecDlg = (CExecDlg*)GetOwner();
		if ( pCExecDlg != NULL ) {
			CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
		}
		else if ( pCExecDlg == NULL ) {
			//e޳̎擾s
			return;
		}

		if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
			return;
		}

		//\tLtO`FbN
		if ( pApp->m_clipUse != 1 ) {
			return;
		}

		pcsXcgIconBtn = &(pApp->m_pccExecDlg->m_IconBtn[pApp->m_clipButtonNum]);
		if ( pcsXcgIconBtn == NULL ) {
			return;
		}

		//ւޔ
		csTitle    = pcsXcgIconBtn->m_csTitle[pApp->m_clipPageNum];
		iItem      = pcsXcgIconBtn->m_iItem[pApp->m_clipPageNum];
		csFileName = pcsXcgIconBtn->m_csFileName[pApp->m_clipPageNum];
		csOption   = pcsXcgIconBtn->m_csOption[pApp->m_clipPageNum];
		iShowFlag  = pcsXcgIconBtn->m_iShowFlag[pApp->m_clipPageNum];
		csIconName = pcsXcgIconBtn->m_csIconName[pApp->m_clipPageNum];
		bIcon      = pcsXcgIconBtn->m_bIcon[pApp->m_clipPageNum];

		//ւɌ{^̏ݒ
		pcsXcgIconBtn->m_csTitle[pApp->m_clipPageNum]    = m_csTitle[m_iSpin];
		pcsXcgIconBtn->m_iItem[pApp->m_clipPageNum]     = m_iItem[m_iSpin];
		pcsXcgIconBtn->m_csFileName[pApp->m_clipPageNum] = m_csFileName[m_iSpin];
		pcsXcgIconBtn->m_csOption[pApp->m_clipPageNum]   = m_csOption[m_iSpin];
		pcsXcgIconBtn->m_iShowFlag[pApp->m_clipPageNum] = m_iShowFlag[m_iSpin];
		pcsXcgIconBtn->m_csIconName[pApp->m_clipPageNum] = m_csIconName[m_iSpin];
		pcsXcgIconBtn->m_bIcon[pApp->m_clipPageNum]     = m_bIcon[m_iSpin];

		//t@CŐ󔒂
		pcsXcgIconBtn->m_csIconName[pApp->m_clipPageNum].TrimLeft();
		pcsXcgIconBtn->m_csIconName[pApp->m_clipPageNum].TrimRight();

		hIcon = LoadAutoIcon( pcsXcgIconBtn->m_csIconName[pApp->m_clipPageNum], pcsXcgIconBtn->m_iItem[pApp->m_clipPageNum] );

		if ( pcsXcgIconBtn->m_phIcon[pApp->m_clipPageNum] != NULL ) {
			::DestroyIcon( pcsXcgIconBtn->m_phIcon[pApp->m_clipPageNum] );
			pcsXcgIconBtn->m_phIcon[pApp->m_clipPageNum] = NULL;
		}
		pcsXcgIconBtn->m_phIcon[pApp->m_clipPageNum] = hIcon;

		//y[WȂ\XV
		if ( pApp->m_clipPageNum == m_iSpin ) {
			//{^ACR̐ݒ
			pcsXcgIconBtn->SetIcon2( pcsXcgIconBtn->m_phIcon[pApp->m_clipPageNum] );

			//x̐ݒ
			CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(pcsXcgIconBtn->m_lLabelID);
			if ( CStaticPtr != NULL ) {
				pcsXcgIconBtn->SetStaticText( CStaticPtr, m_csTitle[pApp->m_clipPageNum] );
			}
		}

		//{^̕ۑ(ICONԍn悤ɕύX)
		iRet = pcsXcgIconBtn->SaveExeInfo( pApp->m_clipPageNum );
		if ( iRet < 0 ) {
			return;
		}

		//{^ɑޔ̏ݒ
		m_csTitle[m_iSpin]    = csTitle;
		m_iItem[m_iSpin]      = iItem;
		m_csFileName[m_iSpin] = csFileName;
		m_csOption[m_iSpin]   = csOption;
		m_iShowFlag[m_iSpin]  = iShowFlag;
		m_csIconName[m_iSpin] = csIconName;
		m_bIcon[m_iSpin]      = bIcon;

		//t@CŐ󔒂
		m_csIconName[m_iSpin].TrimLeft();
		m_csIconName[m_iSpin].TrimRight();

		hIcon = LoadAutoIcon( m_csIconName[m_iSpin], m_iItem[m_iSpin] );

		if ( m_phIcon[m_iSpin] != NULL ) {
			::DestroyIcon( m_phIcon[m_iSpin] );
			m_phIcon[m_iSpin] = NULL;
		}
		m_phIcon[m_iSpin] = hIcon;

		//{^ACR̐ݒ
		SetIcon2( m_phIcon[m_iSpin] );

		//x̐ݒ
		CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
		if ( CStaticPtr != NULL ) {
			SetStaticText( CStaticPtr, m_csTitle[m_iSpin] );
		}

		//{^̕ۑ(ICONԍn悤ɕύX)
		iRet = SaveExeInfo( m_iSpin );
		if ( iRet < 0 ) {
			return;
		}

		return;
	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH
}

void CIconButton::OnDropFiles(HDROP hDropInfo)
{
	CString		csPathName;
	CString		csTitle;
	CString		csOption;
	CString		csIconPath;
	HICON hIcon = NULL;
	CExecDlg* pCExecDlg;
	CStatic* CStaticPtr;
	char cTemp[FILELEN];
	char cTemp2[FILELEN];
	char cIconPath[FILELEN];
	int iIcon = 0;
	int iRet = 0;
	int iRet2 = 0;
	int iTemp = 0;
	int iShowFlag = 0;
	char AssociateName[FILELEN];	//֘Att@C
	BOOL bKanji = FALSE;
	CString csTemp;
	int iCount;
	WIN32_FIND_DATA wfd;
	char cTempName[MAX_PATH+1];
	BOOL blRun;
	DWORD size;
	UINT nr = ERROR_SUCCESS;
	TCHAR szProductCode[39];
	TCHAR szFeatureId[MAX_FEATURE_CHARS + 1];
	TCHAR szComponentCode[39];

	TRY {
		if ( m_iSpin < 0 || m_iSpin > m_iAreaMax - 1 ) {
			return;
		}

		//xID̎擾
		if ( m_lLabelID < 0 ) {
			//G[
			return;
		}

		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			//G[
			return ;
		}

		//hbOꂽt@C擾
		::DragQueryFile( hDropInfo, 0, cTempName, sizeof(cTempName)-1 );
		csPathName = cTempName;
		::DragFinish(hDropInfo);

		//^Cg̎擾
		iRet = csPathName.ReverseFind( _T('\\') );
		iRet2 = csPathName.ReverseFind( _T('.') );
		if ( iRet != -1 ) {
			if ( iRet2 != -1 && iRet2 > iRet ) {
				csTitle = _T(csPathName.Mid(iRet + 1, iRet2 - iRet - 1));
			}
			else {
				csTitle = _T(csPathName.Mid(iRet + 1));
			}
			strcpy( cTemp, _T(csTitle.GetBuffer(csTitle.GetLength())) );
			csTitle.ReleaseBuffer();
		}
		else {
			csTitle = "";
		}

		//V[gJbgt@C̏ꍇÃt@C
		if ( SUCCEEDED(CoInitialize(NULL)) ) {
	        nr = ::MsiGetShortcutTarget(csPathName.GetBuffer(csPathName.GetLength()), szProductCode, szFeatureId, szComponentCode);
			if (nr == ERROR_SUCCESS) {
				::MsiGetComponentPath(szProductCode, szComponentCode, cTempName, &size);
				csPathName.ReleaseBuffer();
				//st@CȊO͏]@
				if ( SUCCEEDED(GetShortcutLink(csPathName.GetBuffer(csPathName.GetLength()), cTemp, cTemp2, cIconPath, &iIcon, FILELEN, &wfd, &iTemp)) ) {
					csPathName = cTempName;
					csOption = cTemp2;
					csIconPath = cIconPath;
					switch( iTemp ) {
					case SW_SHOWNORMAL:
						iShowFlag = 0;
						break;
					case SW_SHOWMINIMIZED:
					case SW_SHOWMINNOACTIVE:
						iShowFlag = 1;
						break;
					case SW_SHOWMAXIMIZED:
						iShowFlag = 2;
						break;
					default:
						break;
					}
				}
				csPathName.ReleaseBuffer();
			}
			else {
				if ( SUCCEEDED(GetShortcutLink(csPathName.GetBuffer(csPathName.GetLength()), cTemp, cTemp2, cIconPath, &iIcon, FILELEN, &wfd, &iTemp)) ) {
					csPathName = cTemp;
					csOption = cTemp2;
					csIconPath = cIconPath;
					switch( iTemp ) {
					case SW_SHOWNORMAL:
						iShowFlag = 0;
						break;
					case SW_SHOWMINIMIZED:
					case SW_SHOWMINNOACTIVE:
						iShowFlag = 1;
						break;
					case SW_SHOWMAXIMIZED:
						iShowFlag = 2;
						break;
					default:
						break;
					}
				}
				csPathName.ReleaseBuffer();
			}
			CoUninitialize();
		}

//Add v0.24
		CString csCheck;
		CString csEXT;
		char cProfile[256];
		long lProfileLen;
		//̂URLt@CȂAURL擾
		csCheck = csPathName.Right(3);
		csEXT = "URL";
		if ( csCheck.CompareNoCase(csEXT) == 0 ) {
			lProfileLen = ::GetPrivateProfileString( "InternetShortcut", "URL", "", cProfile, 255, csPathName );
			if ( lProfileLen == 0 ) {
				strcpy( cProfile, "" );
			}
			else {
				cProfile[lProfileLen] = '\0';
			}
			csPathName = cProfile;
		}
//Add v0.24

		if ( pApp->m_cIniInfo.loadOptionDragRun() == 1 ) {
			blRun = TRUE;
		}
		else {
			blRun = FALSE;
		}

		if ( blRun != FALSE ) {
			if ( m_csFileName[m_iSpin].GetLength() == 0 ) {
				//o^ȂhbOꂽt@C͖ɓo^[h
				blRun = FALSE;
			}
			else {
				//o^t@CEXEłȂΓo^[h
				iRet2 = m_csFileName[m_iSpin].ReverseFind( _T('.') );
				if ( iRet2 != -1 ) {
					csCheck = m_csFileName[m_iSpin].Mid(iRet2 + 1);
					csEXT = "EXE";
					if ( csCheck.CompareNoCase(csEXT) != 0 ) {
						blRun = FALSE;
					}
				}
			}
		}

		if ( blRun != FALSE ) {
			//hbvt@Cst@CȂo^[h
			iRet2 = csPathName.ReverseFind( _T('.') );
			if ( iRet2 != -1 ) {
				csCheck = csPathName.Mid(iRet2 + 1);
				csEXT = "EXE";
				if ( csCheck.CompareNoCase(csEXT) == 0 ) {
					blRun = FALSE;
				}
				csEXT = "COM";
				if ( csCheck.CompareNoCase(csEXT) == 0 ) {
					blRun = FALSE;
				}
			}
		}

		//o^[h
		if ( blRun == FALSE ) {
			//eEBhẼx̃|C^擾
			pCExecDlg = (CExecDlg*)GetOwner();
			if ( pCExecDlg != NULL ) {
				CStaticPtr = (CStatic*)pCExecDlg->GetDlgItem(m_lLabelID);
			}
			else if ( pCExecDlg == NULL ) {
				//e޳̎擾s
				return ;
			}

			//ɓo^ĂΏ㏑mF
			if ( pApp->m_cIniInfo.loadOptionDispOvw() == 1 ) {
				if ( m_csFileName[m_iSpin].GetLength() != 0 ) {
					pCExecDlg->SetForegroundWindow();
					if ( MessageBox( "ۯ߂ꂽ̧ق㏑o^܂B낵łH", ERR_EXEC_TITLE01, MB_ICONQUESTION + MB_OKCANCEL ) != IDOK ) {
						return;
					}
				}
			}

			//^Cg̐ݒ
			m_csTitle[m_iSpin] = csTitle;

			memset( cTemp, 0x00, sizeof(cTemp) );
			memset( AssociateName, 0x00, sizeof(AssociateName) );

			m_csFileName[m_iSpin] = csPathName;

			m_csOption[m_iSpin]   = csOption;

			//
			m_iShowFlag[m_iSpin]   = iShowFlag;

			csTemp = csPathName;
			strcpy( cTemp, _T(csPathName.GetBuffer(csPathName.GetLength())) );
			csPathName.ReleaseBuffer();

			//֘Att@C擾
			if ( GetAssociateFileName( AssociateName, cTemp ) >= NO_ERR ) {
				//֘At̃t@CƓt@CH
				if ( csTemp.CompareNoCase( AssociateName ) != 0 ) {
					iCount = (int)::ExtractIcon( AfxGetInstanceHandle(), AssociateName, (UINT)(-1) );
					if ( iCount <= 0 ) {
						m_iItem[m_iSpin] = 0;
					}
					else if ( iCount >= 2 ) {
						//֘At̃ACRCfbNX擾
						m_iItem[m_iSpin] = getDefaultIconIndex( cTemp );
						if ( m_iItem[m_iSpin] < 0 || m_iItem[m_iSpin] >= iCount ) {
							m_iItem[m_iSpin] = 1;
						}
					}
					m_csIconName[m_iSpin] = AssociateName;
				}
				else {
					if ( csIconPath.GetLength() != 0 && csPathName != csIconPath ) {
						m_bIcon[m_iSpin] = TRUE;
						m_iItem[m_iSpin] = iIcon;
						m_csIconName[m_iSpin] = csIconPath;
					}
					else {
						//t@CɎw肳ꂽ̂̂܂ܐݒ
						m_bIcon[m_iSpin] = FALSE;
						m_iItem[m_iSpin] = iIcon;
						m_csIconName[m_iSpin] = csPathName;
					}
				}
			}
			else {
				if ( csIconPath.GetLength() != 0 && csPathName != csIconPath ) {
					m_bIcon[m_iSpin] = TRUE;
					m_iItem[m_iSpin] = iIcon;
					m_csIconName[m_iSpin] = csIconPath;
				}
				else {
					//t@CɎw肳ꂽ̂̂܂ܐݒ
					m_bIcon[m_iSpin] = FALSE;
					m_iItem[m_iSpin] = iIcon;
					m_csIconName[m_iSpin] = csPathName;
				}
			}

			//t@CŐ󔒂
			m_csIconName[m_iSpin].TrimLeft();
			m_csIconName[m_iSpin].TrimRight();

			hIcon = LoadAutoIcon( m_csIconName[m_iSpin], m_iItem[m_iSpin] );

			if ( m_phIcon[m_iSpin] != NULL ) {
				::DestroyIcon( m_phIcon[m_iSpin] );
				m_phIcon[m_iSpin] = NULL;
			}
			m_phIcon[m_iSpin] = hIcon;

			//{^ACR̐ݒ
			SetIcon2( m_phIcon[m_iSpin] );

			//x̐ݒ
			if ( CStaticPtr != NULL ) {
				SetStaticText( CStaticPtr, m_csTitle[m_iSpin] );
			}

			//{^̕ۑ(ICONԍn悤ɕύX)
			iRet = SaveExeInfo( m_iSpin );
			if ( iRet < 0 ) {
				return;
			}
		}
		//s[h
		else {
			RunIcon( csPathName );
		}

		return;
	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH

	return;
}

HRESULT CIconButton::GetShortcutLink(LPSTR pszLink, LPSTR pszFilePath, LPSTR pszOption, LPSTR pszIconPath, int* piIcon, int cchMaxPath, WIN32_FIND_DATA *wfd, int* piShowFlag )
{
	HRESULT hres;
	IShellLink *psl;

	// IShellLink IuWFNg쐬|C^擾
	hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
                                            IID_IShellLink, (void **)&psl);

	if (SUCCEEDED(hres)) {
		IPersistFile *ppf;

		// IPersistFile C^[tFCX̖₢킹Ȃ
		hres = psl->QueryInterface( IID_IPersistFile, (void **)&ppf );
		if ( SUCCEEDED(hres) ) {
			WCHAR wsz[MAX_PATH];										// Unicode ւ̃obt@

			// ANSIō\悤ɂ
			MultiByteToWideChar(CP_ACP, 0, pszLink, -1, wsz, MAX_PATH);

			// V[gJbg[h
			hres = ppf->Load( wsz, STGM_READ );

			if (SUCCEEDED(hres)) {
				hres = psl->Resolve( NULL, SLR_NO_UI|SLR_NOUPDATE );
				if (SUCCEEDED(hres)) {
					// N擾
					hres = psl->GetPath( pszFilePath, cchMaxPath, wfd, SLGP_UNCPRIORITY );
					// IvV擾
					psl->GetArguments( pszOption, cchMaxPath );
					// \IvV擾
					psl->GetShowCmd( piShowFlag );
					// ACRʒu擾
					psl->GetIconLocation( pszIconPath, cchMaxPath, piIcon );
				}
			}

			// IPersistFile ւ̃|C^J
			psl->Release();
		}
		// IShellLinkւ̃|C^J
		psl->Release();
	}
	return hres;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::GetSectionIndex
//\bhF{^ɑΉZNVindex̎擾
//`    F  int CIconButton::GetSectionIndex(
//              F  )
//^[l  FZNVindex
//O        FȂ
//쐬N  F2001/02/06
//쐬Җ    FMacBS
//l        F{^\[X𖼑OŌĂB\[XύX͗v
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CIconButton::GetSectionIndex( CString& csButtonName )
{
	CString CButtonName;
	CString CButtonIndex;
	char cButtonIndex;
	long lIndex;

	TRY {
		//{^̎擾
		CButtonName = csButtonName;

		if ( CButtonName.Left(6) == ICBTB_LBE ) {

			CButtonIndex = CButtonName.Right(1);
			memcpy( &cButtonIndex, CButtonIndex.GetBuffer(CButtonIndex.GetLength()), sizeof(char) );
			CButtonIndex.ReleaseBuffer();

			if ( cButtonIndex >= '0' && cButtonIndex <= '9' ) {
				lIndex = (long)cButtonIndex - (long)'0' - 1;
			}
			else if ( cButtonIndex >= 'A' && cButtonIndex <= 'Z' ) {
				lIndex = (long)cButtonIndex - (long)'A' + 10 - 1;
			}
			else if ( cButtonIndex >= 'a' && cButtonIndex <= 'z' ) {
				lIndex = (long)cButtonIndex - (long)'a' + 10 - 1;
			}
			else {
				return( -1 );
			}

			if ( lIndex < 0 || lIndex >= EXEC_BUTTON_MAX )  {
				return( -1 );
			}

			return( lIndex );
		}
		else {
			return( -1 );
		}

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

void CIconButton::SetStaticText( CStatic*CStaticPtr, CString& csStr )
{
	char cTemp[FILELEN];
	BOOL bKanji = FALSE;
	int i;

	if ( CStaticPtr == NULL ) {
		return;
	}

	if ( csStr.GetLength() > EXEC_TITLE_MAX ) {
		strcpy( cTemp, _T(csStr.GetBuffer(csStr.GetLength())) );
		csStr.ReleaseBuffer();
		for ( bKanji = FALSE, i = 0; i < EXEC_TITLE_MAX; i++ ) {
			//擪R[h
			if ( bKanji == FALSE ) {
				if ( IsKanji_SJIS((unsigned char)(*(cTemp + i))) ) {
					bKanji = TRUE;
				}
				else {
					bKanji = FALSE;
				}
			}
			else {
				bKanji = FALSE;
			}
		}
		if ( bKanji == FALSE ) {
			CStaticPtr->SetWindowText( csStr.Left(EXEC_TITLE_MAX) );
		}
		else {
			CStaticPtr->SetWindowText( csStr.Left(EXEC_TITLE_MAX-1) );
		}
	}
	else {
		CStaticPtr->SetWindowText( csStr );
	}

	return;
}

//Add v0.21
BOOL CIconButton::OnNeedText(UINT nId, NMHDR* pNMHdr, LRESULT* pResult)
{
	BOOL blOnlyLong;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionDispTool() != 0 ) {
			blOnlyLong = FALSE;
		}
		else {
			if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 0 ) {
				blOnlyLong = TRUE;
			}
			else {
				return TRUE;
			}
		}
	}
	else {
		return TRUE;
	}

	TOOLTIPTEXT* pTTT = (TOOLTIPTEXT*)pNMHdr;
	CString csTemp;

	if ( pTTT == NULL ) {
		return TRUE;
	}
	else if ( pTTT->szText == NULL ) {
		return TRUE;
	}

	if ( m_csTitle == NULL ) {
		return TRUE;
	}

	csTemp = m_csTitle[m_iSpin];

	if ( blOnlyLong != FALSE ) {
		if ( csTemp.GetLength() <= EXEC_TITLE_MAX ) {
			return TRUE;
		}
	}
	::lstrcpy( pTTT->szText, csTemp );

	return TRUE;
}
//Add v0.21

void CIconButton::AutoIconName( CString& csFileName, CString& csIconName )
{
	char cTemp[FILELEN];
	char AssociateName[FILELEN];	//֘Att@C

	//ϐ̒u
	dReplaceEnvParam( cTemp, csFileName.GetBuffer(csFileName.GetLength()) );
	csFileName.ReleaseBuffer();
	//t@C擾łH
	if ( strlen( cTemp ) > 0 ) {
		//֘Att@C擾
		if ( GetAssociateFileName( AssociateName, cTemp ) < NO_ERR ) {
			csIconName = csFileName;
		}
		else {
			csIconName = AssociateName;
		}
	}
	else {
		csIconName = csFileName;
	}

	return;
}

HICON CIconButton::LoadAutoIcon( CString& csIconName, int iItem )
{
	HICON hIcon;
	HICON* phIconSmall = NULL;
	struct _stat buf;			//t@C݃`FbNp
	char cTemp[FILELEN];

	//ϐ̒u
	dReplaceEnvParam( cTemp, csIconName.GetBuffer(csIconName.GetLength()) );
	csIconName.ReleaseBuffer();

	//j[̊Yڂ̃ACRLbV̈
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp->m_pccMainFrame != NULL ) {
		if ( pApp->m_pccMainFrame->m_pphIcon != NULL ) {
			int iIndex = m_iSectionIndex;
			if ( pApp->m_pccMainFrame->m_pphIcon[m_iSpin*EXEC_BUTTON_MAX+iIndex] == NULL ) {
				pApp->m_pccMainFrame->m_pphIcon[m_iSpin*EXEC_BUTTON_MAX+iIndex] = new HICON;
				*(pApp->m_pccMainFrame->m_pphIcon[m_iSpin*EXEC_BUTTON_MAX+iIndex]) = NULL;
				phIconSmall = pApp->m_pccMainFrame->m_pphIcon[m_iSpin*EXEC_BUTTON_MAX+iIndex];
			}
		}
	}

	if ( strlen( cTemp ) != 0 ) {
		//t@C̑݃`FbN
		int iRet;
		iRet = _mbstat( cTemp, &buf );
		if ( iRet == 0 ) {
			//ACR̐ݒ
			if ( iItem >= 0 ) {
				//w肳ꂽs\t@CEDLLACR̎擾
//				hIcon = ::ExtractIcon( AfxGetInstanceHandle(), cTemp, iItem );
				::ExtractIconEx( cTemp, iItem, &hIcon, phIconSmall, 1 );
				if ( hIcon == NULL ) {
					//ftHg̃AvP[VACR̎擾
					hIcon = AfxGetApp()->LoadIcon( IDI_DEFICON );
				}
				if ( phIconSmall != NULL ) {
					if ( *phIconSmall == NULL ) {
						*phIconSmall = AfxGetApp()->LoadIcon( IDI_DEFICON );
					}
				}
			}
			else {
				hIcon = NULL;
			}
		}
		else if ( iRet == 1 ) {
			//ftHg̃AvP[VACR̎擾
			hIcon = AfxGetApp()->LoadIcon( IDI_WEBICON );
			if ( phIconSmall != NULL ) {
				if ( *phIconSmall == NULL ) {
					*phIconSmall = AfxGetApp()->LoadIcon( IDI_WEBICON );
				}
			}
		}
		else {
			//ACR̃NA
			hIcon = NULL;
		}
	}
	else {
		//ACR̃NA
		hIcon = NULL;
	}

	return( hIcon );
}

void CIconButton::RunIcon( CString& csDataName )
{
	CString CSectionName;
	char cRunFileName[FILELEN];
	char cRunPathName[FILELEN];
	char cRunOption[FILELEN*2];
	char cTemp[FILELEN];
	int iRet = 0;
	int iRunShow;
	CExecDlg* pExecDlg;
	struct _stat buf;					//t@C݃`FbNp

	TRY {
		memset( cRunFileName, 0x00, sizeof(cRunFileName) );
		memset( cRunOption, 0x00, sizeof(cRunOption) );
		memset( cTemp, 0x00, sizeof(cTemp) );

		//eEBhẼx̃|C^擾
		pExecDlg = (CExecDlg*)GetOwner();
		if ( pExecDlg == NULL ) {
			return;
		}

		//{^BĂ΁Â܂܏I
		if ( pExecDlg->m_blHide == TRUE ) {
			return;
		}

		//{^ZNV擾
		iRet = GetSectionName( m_iSectionIndex, &CSectionName );
		if ( iRet < 0 ) {
			return;
		}

		//ZNV̎擾
		_itoa( m_iSpin, cTemp, 10 );
		CSectionName += cTemp;

		//t@C̎擾
		iRet = GetExeFileInfo( cRunFileName, cRunOption, &iRunShow );
		if ( iRet != 0 ) {
			//G[
			MessageBox( ERR_EXEC_MSG03, ERR_EXEC_TITLE01, MB_ICONEXCLAMATION | MB_OK );
			return;
		}

		//ϐ̒u
		dReplaceEnvParam( cTemp, cRunFileName );

		if ( strlen(cTemp) != 0 ) {
			//t@C̑݃`FbN
			int iRet;
			iRet = _mbstat( cTemp, &buf );
			if ( iRet == 0 ) {
				splitPath( cRunPathName, cRunFileName );
				::SetCurrentDirectory( cRunPathName );
			}
			else if ( iRet == 1 ) {
			}
			else {
				//G[
				MessageBox( ERR_EXEC_MSG04, ERR_EXEC_TITLE01, MB_ICONEXCLAMATION | MB_OK );
				return;
			}
		}
		else {
			//G[
			MessageBox( ERR_EXEC_MSG04, ERR_EXEC_TITLE01, MB_ICONEXCLAMATION | MB_OK );
			return;
		}

		if ( csDataName.GetLength() != 0 ) {
			strcat( cRunOption, " " );
			strcat( cRunOption, "\"" );
			strcat( cRunOption, csDataName.GetBuffer(csDataName.GetLength()) );
			csDataName.ReleaseBuffer();
			strcat( cRunOption, "\"" );
		}

		//EXEt@Cs
		iRet = pExecDlg->IconRecFileRun( cRunFileName, cRunOption, iRunShow );
		if ( iRet != 0 ) {
			return;
		}

		//I
		if ( pExecDlg->m_iEraseAfterRun != 0 ) {
			pExecDlg->ShowWindow( SW_HIDE );
		}
		else if ( pExecDlg->m_iHideAfterRun != 0 ) {
			pExecDlg->ChangeDialogStyle( FALSE );
		}
		//2009.09.02
		else if ( pExecDlg->m_iQuitAfterRun != 0 ) {
			CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
			if ( pApp != NULL ) {
				pApp->m_pccMainFrame->OnAppExit();
			}
		}

	}
	CATCH( CMemoryException, e ) {
		return ;
	} END_CATCH
}

void CIconButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CRect rect;
	int iX;
	int iY;
	int iIconX;
	int iIconY;
	BOOL blZoom = FALSE;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return;
	}

	CDC* dc = CDC::FromHandle( lpDrawItemStruct->hDC );

	// fBoCXReLXgۑ
	dc->SaveDC();

	// ĕ`悷̈擾
	CRect rc = lpDrawItemStruct->rcItem;

	HTHEME hTheme = NULL;
	if ( m_pcTheme != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionFlatIcon() == 0 ) {
			hTheme = m_pcTheme->OpenThemeData( GetSafeHwnd(), L"BUTTON" );
		}
		else {
			hTheme = m_pcTheme->OpenThemeData( GetSafeHwnd(), L"TOOLBAR" );
		}
	}
	else {
		hTheme = NULL;
	}

	// `擮삪Ŝ̍ĕ`́A
	// IԂωꍇ
	if( lpDrawItemStruct->itemAction & ( ODA_DRAWENTIRE | ODA_SELECT ) ||
		lpDrawItemStruct->hwndItem == ::GetFocus() ) {
		if ( pApp->m_cIniInfo.loadOptionCustomButton() != 0 ) {
			int		iStateId = 0;
			// Rg[̏ԂIꂽԂ̏ꍇ
			if( lpDrawItemStruct->itemState & ODS_SELECTED ) {
				iStateId = PBS_PRESSED;
				if ( pApp->m_cIniInfo.loadOptionFocusIcon() != 0 ) {
					if ( pApp->m_cIniInfo.loadOptionBigIcon() == 1 ) {
						blZoom = TRUE;
					}
					else {
						blZoom = FALSE;
					}
				}
				else {
					blZoom = FALSE;
				}
			}
			else if ( m_bMouseOnButton == TRUE ) {
				iStateId = PBS_HOT;
				if ( pApp->m_cIniInfo.loadOptionBigIcon() == 1 ) {
					blZoom = TRUE;
				}
				else {
					blZoom = FALSE;
				}
			}
			else if ( lpDrawItemStruct->hwndItem == ::GetFocus() ) {
				iStateId = PBS_DEFAULTED;
				blZoom = FALSE;
			}
			else {
				iStateId = PBS_NORMAL;
				blZoom = FALSE;
			}

			int iState;
			switch(iStateId) {
				case PBS_NORMAL:
					iState = 0;
					break;
				case PBS_PRESSED:
					iState = 1;
					break;
				case PBS_HOT:
					iState = 2;
					break;
				case PBS_DEFAULTED:
					iState = 3;
					break;
			}

			rect.CopyRect(&lpDrawItemStruct->rcItem);
//			pApp->m_pccExecDlg->m_ciButtonImage[iState].SetTransparentColor(pApp->m_pccExecDlg->m_ciButtonImage[iState].GetPixel(0,0));
//			pApp->m_pccExecDlg->m_ciButtonImage[iState].Draw( lpDrawItemStruct->hDC, 0+3, 0+3, rect.right-rect.left+1-3*2, rect.bottom-rect.top+1-3*2);
			pApp->m_pccExecDlg->m_ciButtonImage[iState].Draw( lpDrawItemStruct->hDC, 0+2, 0+2, rect.right-rect.left+1-2*2, rect.bottom-rect.top+1-2*2);
		}
		else if ( hTheme != NULL && m_pcTheme->IsAppThemed() != FALSE ) {				//XP`Start
			int		iStateId = 0;
			// Rg[̏ԂIꂽԂ̏ꍇ
			if( lpDrawItemStruct->itemState & ODS_SELECTED ) {
				iStateId = PBS_PRESSED;
				if ( pApp->m_cIniInfo.loadOptionFocusIcon() != 0 ) {
					if ( pApp->m_cIniInfo.loadOptionBigIcon() == 1 ) {
						blZoom = TRUE;
					}
					else {
						blZoom = FALSE;
					}
				}
				else {
					blZoom = FALSE;
				}
			}
			else if ( m_bMouseOnButton == TRUE ) {
				iStateId = PBS_HOT;
				if ( pApp->m_cIniInfo.loadOptionBigIcon() == 1 ) {
					blZoom = TRUE;
				}
				else {
					blZoom = FALSE;
				}
			}
			else if ( lpDrawItemStruct->hwndItem == ::GetFocus() ) {
				iStateId = PBS_DEFAULTED;
				blZoom = FALSE;
			}
			else {
				iStateId = PBS_NORMAL;
				blZoom = FALSE;
			}
			m_pcTheme->DrawThemeBackground( hTheme, dc->GetSafeHdc(), BP_PUSHBUTTON, iStateId, rc, NULL);
		}																		//XP`End
		else {																	//]`Start
			// DrawFrameControl()\bh̃tOݒ
			// Rg[̋Ȇ傫AAĂȂ{^
			UINT flg = DFCS_BUTTONPUSH;

			// Rg[̏ԂIꂽԂ̏ꍇ
			if( lpDrawItemStruct->itemState & ODS_SELECTED ) {
				// tOɉꂽ{^̃tOǉ
				flg |= DFCS_PUSHED;
			}

			if ( pApp->m_cIniInfo.loadOptionFlatIcon() == 0 ||
				 lpDrawItemStruct->itemState & ODS_SELECTED ) {
				// Rg[ĕ`悷͈͂
				dc->DrawFrameControl( rc, DFC_BUTTON, flg);
			}
			else {
				dc->FillSolidRect( rc, ::GetSysColor( COLOR_BTNFACE ) );
			}

			// tH[JXƂAANeBủ`悷
			if ( lpDrawItemStruct->hwndItem == ::GetFocus() ) {
				CRect frc;
				rect.CopyRect(&lpDrawItemStruct->rcItem);

				if ( pApp->m_cIniInfo.loadOptionFlatIcon() == 0 ||
					 lpDrawItemStruct->itemState & ODS_SELECTED ) {
					frc.left   = rect.left   + 0;
					frc.top    = rect.top    + 0;
					frc.right  = rect.right  - 0;
					frc.bottom = rect.bottom - 0;
					CPen cPen(PS_SOLID, 1, ::GetSysColor( COLOR_3DDKSHADOW ) );
					CPen* oldP;
					oldP = dc->SelectObject(&cPen);
					dc->MoveTo( frc.left, frc.top );
					dc->LineTo( frc.right, frc.top );
					dc->LineTo( frc.right, frc.bottom );
					dc->LineTo( frc.left, frc.bottom );
					dc->LineTo( frc.left, frc.top );
					dc->SelectObject(oldP);
				}

				// tH[JX̎lpg`悷
				frc.left   = rect.left   + 3;
				frc.top    = rect.top    + 3;
				frc.right  = rect.right  - 3;
				frc.bottom = rect.bottom - 3;
				dc->DrawFocusRect( frc );

				blZoom = FALSE;
			}
			else {
				blZoom = FALSE;
			}
		}																		//]`End

		rect.CopyRect(&lpDrawItemStruct->rcItem);
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp != NULL ) {
			if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 2 ) {
				if ( blZoom == FALSE ) {
//					iIconX = 24;
//					iIconY = 24;
					iIconX = pApp->m_cIniInfo.loadOptionExecDlgSmallIconSize();
					iIconY = pApp->m_cIniInfo.loadOptionExecDlgSmallIconSize();
				}
				else {
//					iIconX = 26;
//					iIconY = 26;
					iIconX = pApp->m_cIniInfo.loadOptionExecDlgSmallIconSize() + 2;
					iIconY = pApp->m_cIniInfo.loadOptionExecDlgSmallIconSize() + 2;
				}
			}
			else if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 1 ) {
				if ( blZoom == FALSE ) {
					iIconX = ::GetSystemMetrics( SM_CXICON );
					iIconY = ::GetSystemMetrics( SM_CYICON );
				}
				else {
					iIconX = (int)(::GetSystemMetrics( SM_CXICON ) * 1.2);
					iIconY = (int)(::GetSystemMetrics( SM_CYICON ) * 1.2);
				}
			}
			else {
				if ( blZoom == FALSE ) {
					iIconX = ::GetSystemMetrics( SM_CXICON );
					iIconY = ::GetSystemMetrics( SM_CYICON );
				}
				else {
					iIconX = (int)(::GetSystemMetrics( SM_CXICON ) * 1.3);
					iIconY = (int)(::GetSystemMetrics( SM_CYICON ) * 1.3);
				}
			}
		}
		else {
			if ( blZoom == FALSE ) {
				iIconX = ::GetSystemMetrics( SM_CXICON );
				iIconY = ::GetSystemMetrics( SM_CYICON );
			}
			else {
				iIconX = (int)(::GetSystemMetrics( SM_CXICON ) * 1.2);
				iIconY = (int)(::GetSystemMetrics( SM_CYICON ) * 1.2);
			}
		}
		if( lpDrawItemStruct->itemState & ODS_SELECTED ) {
			iX = rect.left+(rect.Width()-iIconX)/2 + 1;
			iY = rect.top+(rect.Height()-iIconY)/2 + 1;
		}
		else {
			iX = rect.left+(rect.Width()-iIconX)/2;
			iY = rect.top+(rect.Height()-iIconY)/2;
		}

		int iRet = dc->SetStretchBltMode(HALFTONE);

		if ( m_hIcon_Old != NULL ) {
			if ( pApp->m_cIniInfo.loadOptionDlgVertical() == 0 ) {
				if ( m_iDirection == 1 ) {
					DrawIconXP( lpDrawItemStruct->hDC, iX, iY-iIconY/2, m_hIcon_Old, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
					if ( m_hIcon != NULL ) {
						DrawIconXP( lpDrawItemStruct->hDC, iX, iY+iIconY/2, m_hIcon, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
					}
				}
				else {
					if ( m_hIcon != NULL ) {
						DrawIconXP( lpDrawItemStruct->hDC, iX, iY-iIconY/2, m_hIcon, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
					}
					DrawIconXP( lpDrawItemStruct->hDC, iX, iY+iIconY/2, m_hIcon_Old, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
				}
			}
			else {
				if ( m_iDirection == 1 ) {
					DrawIconXP( lpDrawItemStruct->hDC, iX-iIconX/2, iY, m_hIcon_Old, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
					if ( m_hIcon != NULL ) {
						DrawIconXP( lpDrawItemStruct->hDC, iX+iIconX/2, iY, m_hIcon, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
					}
				}
				else {
					if ( m_hIcon != NULL ) {
						DrawIconXP( lpDrawItemStruct->hDC, iX-iIconX/2, iY, m_hIcon, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
					}
					DrawIconXP( lpDrawItemStruct->hDC, iX+iIconX/2, iY, m_hIcon_Old, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
				}
			}
			m_hIcon_Old = NULL;
		}
		else {
			if ( m_hIcon != NULL ) {
				DrawIconXP( lpDrawItemStruct->hDC, iX, iY, m_hIcon, iIconX, iIconY, 0, NULL, DI_IMAGE | DI_MASK );
			}
		}

		dc->SetStretchBltMode(iRet);
	}

	if ( hTheme != NULL ) {
		m_pcTheme->CloseThemeData(hTheme);
	}

	// fBoCXReLXgɖ߂
	dc->RestoreDC( -1);
}

void CIconButton::SetIcon2( HICON hIcon )
{
	m_hIcon_Old = NULL;
	m_hIcon = hIcon;
	InvalidateRect(NULL);
}

void CIconButton::SetIcon3( HICON hIcon, int iDirection )
{
	m_hIcon_Old = m_hIcon;
	m_iDirection = iDirection;

	m_hIcon = hIcon;
	InvalidateRect(NULL);
}

void CIconButton::OnMouseMove(UINT nFlags, CPoint point)
{
	CButton::OnMouseMove( nFlags, point );

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionFocusIcon() != 0 ) {
			CWnd*				wndUnderMouse = NULL;
			TRACKMOUSEEVENT		csTME;

			ClientToScreen( &point );
			wndUnderMouse = WindowFromPoint( point );

			if ( nFlags & MK_LBUTTON && m_bMouseOnButton == FALSE ) {
				return;
			}

			if ( wndUnderMouse && wndUnderMouse->m_hWnd == m_hWnd ) {
				if ( !m_bMouseOnButton ) {
					m_bMouseOnButton = TRUE;
					InvalidateXP();
					csTME.cbSize = sizeof(csTME);
					csTME.dwFlags = TME_LEAVE;
					csTME.hwndTrack = m_hWnd;
					::_TrackMouseEvent(&csTME);
				}
			}
			else {
				CancelHover();
			}
		}
	}
}

void CIconButton::CancelHover()
{
	if ( m_bMouseOnButton ) {
		m_bMouseOnButton = FALSE;
		InvalidateXP();
	}
}

LRESULT CIconButton::OnMouseLeave(WPARAM wParam, LPARAM lParam)
{
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionFocusIcon() != 0 ) {
			CancelHover();
		}
	}
	return 0;
}

void CIconButton::OnKillFocus(CWnd * pNewWnd)
{
	CButton::OnKillFocus(pNewWnd);

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp->m_cIniInfo.loadOptionFlatIcon() != 0 ) {
		InvalidateXP();
	}
}

void CIconButton::InvalidateXP()
{
	HTHEME hTheme = NULL;
	if ( m_pcTheme != NULL ) {
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp->m_cIniInfo.loadOptionFlatIcon() == 0 ) {
			hTheme = m_pcTheme->OpenThemeData( GetSafeHwnd(), L"BUTTON" );
		}
		else {
			hTheme = m_pcTheme->OpenThemeData( GetSafeHwnd(), L"TOOLBAR" );
		}
	}
	else {
		hTheme = NULL;
	}

	if ( hTheme != NULL && m_pcTheme->IsAppThemed() != FALSE ) {
		Invalidate();
	}

	if ( hTheme != NULL ) {
		m_pcTheme->CloseThemeData(hTheme);
	}
}

void CIconButton::DrawIconXP( HDC hdc, int xLeft, int yTop, HICON hIcon, int cxWidth, int cyWidth, UINT istepIfAniCur, HBRUSH hbrFlickerFreeDraw, UINT diFlags)
{
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() != 2 ) {
			::DrawIconEx( hdc, xLeft, yTop, hIcon, cxWidth, cyWidth, istepIfAniCur, hbrFlickerFreeDraw, diFlags );
		}
		else {
			ICONINFO ii;
			GetIconInfo(hIcon, &ii);

			HDC dcImage = ::CreateCompatibleDC(NULL);

			BOOL blFlg = FALSE;
			BITMAP bmap;
			int nBit = GetObject(ii.hbmColor, sizeof(bmap), &bmap);

			if ( bmap.bmBitsPixel != 32 ) {
				blFlg = FALSE;
			}
			else {
				BYTE *mbits = new BYTE[bmap.bmWidthBytes * bmap.bmHeight];
				if ( mbits == NULL ) {
					blFlg = FALSE;
				}
				else {
					BOOL success = GetBitmapBits(ii.hbmColor,bmap.bmWidthBytes*bmap.bmHeight , mbits);
					if ( !success ) {
						blFlg = FALSE;
						delete[] mbits;
						mbits = NULL;
					}
					else {
						for ( long il = 3; il < bmap.bmWidthBytes*bmap.bmHeight; il+=4 ) {
							if ( mbits[il] != 0 ) {
								blFlg = TRUE;
								break;
							}
						}
					}
				}
				if ( mbits != NULL ) {
					delete[] mbits;
					mbits = NULL;
				}
			}

			if ( blFlg == TRUE ) {

				BLENDFUNCTION bf;
				bf.BlendOp = AC_SRC_OVER;
				bf.BlendFlags = 0;
				bf.SourceConstantAlpha = 255;
				bf.AlphaFormat = AC_SRC_ALPHA;

				HBITMAP hOldBitmapImage = (HBITMAP)::SelectObject(dcImage, ii.hbmColor);

				::AlphaBlend(hdc,  xLeft, yTop, cxWidth, cyWidth, dcImage, 0, 0, bmap.bmWidth, bmap.bmHeight, bf);

				SelectObject(dcImage, hOldBitmapImage);

			}
			else {

				HDC dcTrans = ::CreateCompatibleDC(NULL);

				HBITMAP hBmp = CreateCompatibleBitmap(hdc, bmap.bmWidth, bmap.bmHeight);      
				HBITMAP hOldBitmapTrans = (HBITMAP)::SelectObject(dcTrans, hBmp);

				StretchBlt(dcTrans, 0, 0, bmap.bmWidth, bmap.bmHeight, hdc, xLeft, yTop, cxWidth, cyWidth, SRCCOPY);

				HBITMAP hOldBitmapImage = (HBITMAP)::SelectObject(dcImage, ii.hbmMask);
				BitBlt(dcTrans, 0, 0, bmap.bmWidth, bmap.bmHeight, dcImage, 0, 0, SRCAND);

				::SelectObject(dcImage, ii.hbmColor);
				BitBlt(dcTrans, 0, 0, bmap.bmWidth, bmap.bmHeight, dcImage, 0, 0, SRCPAINT);

				StretchBlt(hdc, xLeft, yTop, cxWidth, cyWidth, dcTrans, 0, 0, bmap.bmWidth, bmap.bmHeight, SRCCOPY);

				SelectObject(dcTrans, hOldBitmapTrans);
				SelectObject(dcImage, hOldBitmapImage);

				DeleteObject(hBmp);
				DeleteDC(dcTrans);
			}

			DeleteObject(ii.hbmColor);
			DeleteObject(ii.hbmMask);
			DeleteDC(dcImage);
		}
	}
}

void CIconButton::SaveIconCache( void )
{
	long lLoop;
	ICONINFO ii;
	CString FName;
	CFile fobj;
	CFileException err;
	BYTE *mbits;
	BITMAP bmap;
	long iButtonCount;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	iButtonCount = pApp->m_cIniInfo.loadOptionButtonCount();
	if ( m_iSectionIndex >= iButtonCount ) {
		return;
	}

	char cFullName[EXECFILEMAX];
	char cPathName[EXECFILEMAX];

	::GetModuleFileName( NULL, cFullName, EXECFILEMAX-1 );
	splitPath( cPathName, cFullName );

	FName.Format( "%s\\mbcache%02ld.dat", cPathName, m_iSectionIndex );

	if( fobj.Open( FName, CFile::modeCreate | CFile::modeWrite, &err) == FALSE ) {
		return;
	}

	fobj.Write( "MBLaunch Icon Cache Data", sizeof("MBLaunch Icon Cache Data") );
	fobj.Write( &m_iAreaMax, sizeof(m_iAreaMax) );

	for ( lLoop = 0; lLoop < m_iAreaMax; lLoop++ ) {
		if ( m_phIcon[lLoop] != NULL ) {

			fobj.Write( "DATA", sizeof("DATA") );

			GetIconInfo(m_phIcon[lLoop], &ii);

			fobj.Write( &(ii.fIcon), sizeof(ii.fIcon) );
			fobj.Write( &(ii.xHotspot), sizeof(ii.xHotspot) );
			fobj.Write( &(ii.yHotspot), sizeof(ii.yHotspot) );

			GetObject(ii.hbmColor, sizeof(bmap), &bmap);

			fobj.Write( &(bmap.bmWidthBytes), sizeof(bmap.bmWidthBytes) );
			fobj.Write( &(bmap.bmHeight), sizeof(bmap.bmHeight) );
			fobj.Write( &(bmap.bmWidth), sizeof(bmap.bmWidth) );
			fobj.Write( &(bmap.bmPlanes), sizeof(bmap.bmPlanes) );
			fobj.Write( &(bmap.bmBitsPixel), sizeof(bmap.bmBitsPixel) );
			fobj.Write( &(bmap.bmType), sizeof(bmap.bmType) );
			fobj.Write( &(bmap.bmBits), sizeof(bmap.bmBits) );

			mbits = new BYTE[bmap.bmWidthBytes * bmap.bmHeight];
			if ( mbits == NULL ) {
				fobj.Close();
				return;
			}
			else {
				BOOL success = GetBitmapBits(ii.hbmColor,bmap.bmWidthBytes*bmap.bmHeight , mbits);
				if ( !success ) {
					fobj.Close();
					return;
				}
				else {
				}
				fobj.Write( mbits, bmap.bmWidthBytes*bmap.bmHeight );
			}

			if ( mbits != NULL ) {
				delete[] mbits;
				mbits = NULL;
			}

			GetObject(ii.hbmMask, sizeof(bmap), &bmap);

			fobj.Write( &(bmap.bmWidthBytes), sizeof(bmap.bmWidthBytes) );
			fobj.Write( &(bmap.bmHeight), sizeof(bmap.bmHeight) );
			fobj.Write( &(bmap.bmWidth), sizeof(bmap.bmWidth) );
			fobj.Write( &(bmap.bmPlanes), sizeof(bmap.bmPlanes) );
			fobj.Write( &(bmap.bmBitsPixel), sizeof(bmap.bmBitsPixel) );
			fobj.Write( &(bmap.bmType), sizeof(bmap.bmType) );
			fobj.Write( &(bmap.bmBits), sizeof(bmap.bmBits) );

			mbits = new BYTE[bmap.bmWidthBytes * bmap.bmHeight];
			if ( mbits == NULL ) {
				fobj.Close();
				return;
			}
			else {
				BOOL success = GetBitmapBits(ii.hbmMask,bmap.bmWidthBytes*bmap.bmHeight , mbits);
				if ( !success ) {
					fobj.Close();
					return;
				}
				else {
				}
				fobj.Write( mbits, bmap.bmWidthBytes*bmap.bmHeight );
			}

			if ( mbits != NULL ) {
				delete[] mbits;
				mbits = NULL;
			}
		}
		else {
			fobj.Write( "NULL", sizeof("NULL") );
		}

	}

	fobj.Close();

	return;
}

void CIconButton::LoadIconCache( void )
{
	long lLoop;
	CString FName;
	CFile fobj;
	CFileException err;
	BYTE *mbitsAND;
	BYTE *mbitsXOR;
	BITMAP bmapAND;
	BITMAP bmapXOR;
	long iButtonCount;
	char cTemp[5];
	ICONINFO ii;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	iButtonCount = pApp->m_cIniInfo.loadOptionButtonCount();
	if ( m_iSectionIndex >= iButtonCount ) {
		return;
	}

	char cFullName[EXECFILEMAX];
	char cPathName[EXECFILEMAX];

	::GetModuleFileName( NULL, cFullName, EXECFILEMAX-1 );
	splitPath( cPathName, cFullName );

	FName.Format( "%s\\mbcache%02ld.dat", cPathName, m_iSectionIndex );

	if( fobj.Open( FName, CFile::modeRead, &err) == FALSE ) {
		return;
	}

	fobj.SeekToBegin();
	fobj.Seek( sizeof("MBLaunch Icon Cache Data"), CFile::begin );
	fobj.Seek( sizeof(m_iAreaMax), CFile::current );

	for ( lLoop = 0; lLoop < m_iAreaMax; lLoop++ ) {

		strcpy( cTemp, "" );
		fobj.Read( cTemp, 5 );
		cTemp[4] = '\0';

		if ( strcmp( cTemp, "DATA" ) == 0 ) {

			fobj.Seek( sizeof(ii.fIcon), CFile::current );
			fobj.Seek( sizeof(ii.xHotspot), CFile::current );
			fobj.Seek( sizeof(ii.yHotspot), CFile::current );

			fobj.Read( &(bmapAND.bmWidthBytes), sizeof(bmapAND.bmWidthBytes) );
			fobj.Read( &(bmapAND.bmHeight), sizeof(bmapAND.bmHeight) );
			fobj.Read( &(bmapAND.bmWidth), sizeof(bmapAND.bmWidth) );
			fobj.Read( &(bmapAND.bmPlanes), sizeof(bmapAND.bmPlanes) );
			fobj.Read( &(bmapAND.bmBitsPixel), sizeof(bmapAND.bmBitsPixel) );
			fobj.Read( &(bmapAND.bmType), sizeof(bmapAND.bmType) );
			fobj.Read( &(bmapAND.bmBits), sizeof(bmapAND.bmBits) );
			mbitsAND = new BYTE[bmapAND.bmWidthBytes * bmapAND.bmHeight];
			if ( mbitsAND == NULL ) {
				continue;
			}
			fobj.Read( mbitsAND, bmapAND.bmWidthBytes*bmapAND.bmHeight );
			bmapAND.bmBits = mbitsAND;
			ii.hbmColor = CreateBitmapIndirect(&bmapAND);

			fobj.Read( &(bmapXOR.bmWidthBytes), sizeof(bmapXOR.bmWidthBytes) );
			fobj.Read( &(bmapXOR.bmHeight), sizeof(bmapXOR.bmHeight) );
			fobj.Read( &(bmapXOR.bmWidth), sizeof(bmapXOR.bmWidth) );
			fobj.Read( &(bmapXOR.bmPlanes), sizeof(bmapXOR.bmPlanes) );
			fobj.Read( &(bmapXOR.bmBitsPixel), sizeof(bmapXOR.bmBitsPixel) );
			fobj.Read( &(bmapXOR.bmType), sizeof(bmapXOR.bmType) );
			fobj.Read( &(bmapXOR.bmBits), sizeof(bmapXOR.bmBits) );
			mbitsXOR = new BYTE[bmapXOR.bmWidthBytes * bmapXOR.bmHeight];
			if ( mbitsXOR == NULL ) {
				continue;
			}
			fobj.Read( mbitsXOR, bmapXOR.bmWidthBytes*bmapXOR.bmHeight );
			bmapXOR.bmBits = mbitsXOR;
			ii.hbmMask = CreateBitmapIndirect(&bmapXOR);

			m_phIcon[lLoop] = CreateIconIndirect(&ii);

			if ( mbitsAND != NULL ) {
				delete[] mbitsAND;
				mbitsAND = NULL;
			}

			if ( mbitsXOR != NULL ) {
				delete[] mbitsXOR;
				mbitsXOR = NULL;
			}

		}
	}

	fobj.Close();

	return;
}

void CIconButton::DeleteIconCache( void )
{
	CString FName;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();

	char cFullName[EXECFILEMAX];
	char cPathName[EXECFILEMAX];

	::GetModuleFileName( NULL, cFullName, EXECFILEMAX-1 );
	splitPath( cPathName, cFullName );

	FName.Format( "%s\\mbcache%02ld.dat", cPathName, m_iSectionIndex );

	TRY
	{
		CFileStatus rStatus;
		if( CFile::GetStatus( FName, rStatus) == TRUE ) {
			CFile::Remove( FName );
		}
	}
	CATCH( CFileException, e )
	{
	}
	END_CATCH

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCIconButton::OnMouseWheel
//\bhF}EXzC[̃Cxgnh
//`    F  BOOL CIconButton::OnMouseWheel(
//@@@@@@@F    [in]   UINT nFlags    :  }EX
//@@@@@@@F    [in]   short zDelta   :  ]
//@@@@@@@F    [in]   CPoint pt      :  J[\W
//              F  )
//^[l  F0ȊO=L, 0=
//O        FȂ
//쐬N  F2006/07/26
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
BOOL CIconButton::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	int iSpin;

	CRect  rcWindow;
	//EBhEʒu擾
	GetWindowRect( rcWindow );

	//EBhEʒuƃ}EX|C^̔r
	if( rcWindow.PtInRect( pt ) != FALSE && (::GetKeyState(VK_LCONTROL) < 0 || ::GetKeyState(VK_RCONTROL) < 0) ) {
		if ( zDelta < 0 ) {
			iSpin = m_iSpin;
			iSpin++;
		}
		else if ( zDelta > 0 ) {
			iSpin = m_iSpin;
			iSpin--;
		}

		if ( zDelta != 0 ) {
			if ( iSpin > m_iAreaMax - 1 ) {
				iSpin = 0;
			}
			else if ( iSpin < 0 ) {
				iSpin = m_iAreaMax - 1;
			}
			ToggleChange( iSpin );
		}

		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return FALSE;
		}
		if ( pApp->m_cIniInfo.loadOptionNoAnime() == 0 ) {
			UpdateWindow();
			Sleep(20);
			InvalidateRect(NULL);
			UpdateWindow();

			int i;
			BOOL blFlg = FALSE;
			int iPage = -1;
			for ( i = 0; i < pApp->m_pccExecDlg->m_iButtonCount; i++ ) {
				if ( iPage == -1 ) {
					iPage = pApp->m_pccExecDlg->m_IconBtn[i].m_iSpin;
				}
				if ( iPage != pApp->m_pccExecDlg->m_IconBtn[i].m_iSpin ) {
					blFlg = TRUE;
					break;
				}
			}

			if ( blFlg == TRUE ) {
				pApp->m_pccExecDlg->m_cSpinST.SetWindowText( "-" );

				CString csTitle;
				csTitle = APP_NAME;
				csTitle += DLG_CAP;
				csTitle += "[Custom]";
				pApp->m_pccExecDlg->SetWindowText( csTitle );
			}
			else {
				CString csTemp;
				char cTemp2[512];
				CString csTitle;

				pApp->m_pccExecDlg->m_iNowSpin = iPage;

				csTemp.Format( "%d", pApp->m_pccExecDlg->m_iNowSpin+1 );
				pApp->m_pccExecDlg->m_cSpinST.SetWindowText( csTemp.GetBuffer(csTemp.GetLength()) );

				strcpy( pApp->m_pccExecDlg->m_cSpinData, csTemp.GetBuffer(csTemp.GetLength()) );

				csTemp.ReleaseBuffer();

				cTemp2[0] = '\0';
				pApp->m_cIniInfo.loadPageName( pApp->m_pccExecDlg->m_iNowSpin+1, cTemp2 );

				csTitle = APP_NAME;
				csTitle += DLG_CAP;
				csTitle += cTemp2;
				pApp->m_pccExecDlg->SetWindowText( csTitle );
			}
		}

		return TRUE;
//		return FALSE;
	}
	else {
//		CButton::OnMouseWheel(nFlags, zDelta, pt);
		return FALSE;
//		return TRUE;
	}

}

