// IniInfo.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "mblaunch.h"
#include "Comfunc.h"
#include "IniInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIniInfo

IMPLEMENT_DYNCREATE(CIniInfo, CCmdTarget)

CIniInfo::CIniInfo()
{
	long i;
	long j;

	for ( i = 0; i < EXEC_PAGE_MAX; i++ ) {
		m_PageNoDisp[i] = -1;
		m_pcsPageName[i] = NULL;
		for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
			m_pcsFileName[i*EXEC_BUTTON_MAX+j] = NULL;
			m_pcsTitle[i*EXEC_BUTTON_MAX+j] = NULL;
		}
	}

	m_lExecDlgX = -1000;
	m_lExecDlgY = -1000;

	m_iButtonCount = -1;
	m_iAreaMax = -1;
	m_iLaunchMenu = -1;
	m_iDragRun = -1;
	m_iDispOvw = -1;
	m_iDispTool = -1;
	m_iTransparent = -1;
	m_iTopMost = -1;
	m_iNoAnime = -1;
	m_iExecDlgSmall = -1;
	m_iExecDlgSmallIconSize = -1;
	m_iFocusIcon = -1;
	m_iFlatIcon = -1;
	m_iPreIcon = -1;
	m_iBigIcon = -1;
	m_iSearchMode = -1;
	m_iSearchRun = -1;
	m_iCustomButton = -1;
	m_iDlgVertical = -1;
	m_iSingleClickDlg = -1;

	m_pcsCBPathName = NULL;
}

CIniInfo::~CIniInfo()
{
	long i;
	long j;

	if ( m_pcsCBPathName != NULL ) {
		delete m_pcsCBPathName;
		m_pcsCBPathName = NULL;
	}

	for ( i = 0; i < EXEC_PAGE_MAX; i++ ) {
		//y[WLbV̍폜
		if ( m_pcsPageName[i] != NULL ) {
			delete m_pcsPageName[i];
			m_pcsPageName[i] = NULL;
		}
		for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
			//t@CLbV̍폜
			if ( m_pcsFileName[i*EXEC_BUTTON_MAX+j] != NULL &&
				 m_pcsFileName[i*EXEC_BUTTON_MAX+j] != (CString*)(NULL + 1) ) {
				delete m_pcsFileName[i*EXEC_BUTTON_MAX+j];
				m_pcsFileName[i*EXEC_BUTTON_MAX+j] = NULL;
			}
			//^CgLbV̍폜
			if ( m_pcsTitle[i*EXEC_BUTTON_MAX+j] != NULL &&
				 m_pcsTitle[i*EXEC_BUTTON_MAX+j] != (CString*)(NULL + 1) ) {
				delete m_pcsTitle[i*EXEC_BUTTON_MAX+j];
				m_pcsTitle[i*EXEC_BUTTON_MAX+j] = NULL;
			}
		}
	}
}


BEGIN_MESSAGE_MAP(CIniInfo, CCmdTarget)
	//{{AFX_MSG_MAP(CIniInfo)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIniInfo bZ[W nh
long CIniInfo::loadPageNoDisp( int iPageNo )
{
	if ( m_PageNoDisp[iPageNo-1] == -1 ) {
		char cProfile[256];
		CString csTemp;

		//Iniݒ擾
		csTemp.Format( "PageNoDisp%d", iPageNo );

		loadOptionCommon( "PAGE", csTemp.GetBuffer(csTemp.GetLength()), "0", cProfile );
		csTemp.ReleaseBuffer();

		m_PageNoDisp[iPageNo-1] = atol(cProfile);
	}

	return( m_PageNoDisp[iPageNo-1] );
}

void CIniInfo::savePageNoDisp( int iPageNo, long lNoDisp )
{
	char cIniFileName[512];
	CString csTemp;
	CString csTemp2;

	m_PageNoDisp[iPageNo-1] = lNoDisp;

	//Iniݒ擾
	getIniFileName( cIniFileName );
	csTemp2.Format( "PageNoDisp%d", iPageNo );
	csTemp.Format( "%ld", lNoDisp );
	::WritePrivateProfileString( "PAGE", csTemp2, csTemp, cIniFileName );

	return;
}

int CIniInfo::loadButtonFileName( int iButtonIndex, int iSpinIndex, char* pcFileName )
{
	int iRet = 0;
	CString CSectionName;
	char cTemp[EXEC_TEMP_MAX];
	CString csSpin;
	CString* pcsTemp;

	if ( pcFileName == NULL ) {
		return( -1 );
	}

	if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
		return( -1 );
	}

	if ( iSpinIndex > EXEC_PAGE_MAX ) {
		return( -1 );
	}

	if ( m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == NULL ) {
		TRY {
			//{^ɑΉZNV̎擾
			iRet = GetSectionName( iButtonIndex, &CSectionName );
			if ( iRet < 0 ) {
				return( -1 ) ;
			}

			csSpin.Format( "%d", iSpinIndex );
			CSectionName += csSpin;

			//t@C̎擾
			iRet = loadOptionCommon( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_EXEFILE, "", cTemp );
			CSectionName.ReleaseBuffer();

			if ( iRet == 0 ) {
				m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = new CString;
				pcsTemp = m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
				*pcsTemp = cTemp;
			}
			else {
				m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = (CString*)(NULL + 1);
			}
		}
		CATCH( CMemoryException, e ) {
			iRet = -1;
		} END_CATCH
	}
	else if ( m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == (CString*)(NULL + 1) ) {
		iRet = -1;
	}
	else {
		iRet = 0;
	}

	if ( iRet == 0 ) {
		pcsTemp = m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
		strcpy( pcFileName, pcsTemp->GetBuffer(pcsTemp->GetLength()) );
		pcsTemp->ReleaseBuffer();
	}
	else {
		strcpy( pcFileName, "" );
	}

	return( iRet );
}

int CIniInfo::saveButtonFileName( int iButtonIndex, int iSpinIndex, char* pcFileName )
{
	int iRet = 0 ;
	CString CSectionName ;
	char cIniFileName[512];
	CString csSpin;
	CString* pcsTemp;

	TRY {
		if ( pcFileName == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		getIniFileName( cIniFileName );

		//t@C̕ۑ
		::WritePrivateProfileString( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_EXEFILE, pcFileName, cIniFileName );
		CSectionName.ReleaseBuffer();

		if ( strlen(pcFileName) > 0 ) {
			if ( m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == NULL ||
				 m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == (CString*)(NULL + 1) ) {
				m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = new CString;
			}
			pcsTemp = m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
			*pcsTemp = pcFileName;
		}
		else {
			if ( m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == NULL ||
				 m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == (CString*)(NULL + 1) ) {
				m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = (CString*)(NULL + 1);
			}
			else {
				//mۂĂ̈
				delete m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
				m_pcsFileName[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = (CString*)(NULL + 1);
			}
		}

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

int CIniInfo::loadButtonPageNum( int iButtonIndex )
{
	CString CButtonName;
	char cIniFileName[512];

	TRY {
		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		CButtonName.Format( "PageNum%d", iButtonIndex );

		getIniFileName( cIniFileName );

		char cProfile[256];

		CButtonName.Format( "PageNum%d", iButtonIndex );

		//Iniݒ擾
		loadOptionCommon( "PAGE", CButtonName.GetBuffer(CButtonName.GetLength()), "-1", cProfile );

		return( atoi(cProfile) );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

int CIniInfo::saveButtonPageNum( int iButtonIndex, int iPageNum )
{
	int iRet = 0 ;
	CString CButtonName;
	char cIniFileName[512];
	CString csPage;

	TRY {
		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iPageNum > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		CButtonName.Format( "PageNum%d", iButtonIndex );
		csPage.Format( "%d", iPageNum );

		getIniFileName( cIniFileName );

		::WritePrivateProfileString( "PAGE", CButtonName.GetBuffer(CButtonName.GetLength()), csPage.GetBuffer(csPage.GetLength()), cIniFileName );
		CButtonName.ReleaseBuffer();
		csPage.ReleaseBuffer();

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

int CIniInfo::loadOptionButtonCount( void )
{
	if ( m_iButtonCount == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "ButtonCount", EXEC_BUTTON_DEF, cProfile );

		m_iButtonCount = atoi(cProfile);
	}

	return( m_iButtonCount );
}

void CIniInfo::saveOptionButtonCount( int iVal )
{
	if ( iVal == loadOptionButtonCount() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	if ( iVal > EXEC_BUTTON_MAX ) {
		iVal = EXEC_BUTTON_MAX;
	}

	saveOptionCommon( "ButtonCount", (long)iVal );

	m_iButtonCount = iVal;

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionAreaMax
//\bhFXsy[Wő吔̓Ǎ
//`    F  int loadOptionAreaMax(
//              F  )
//^[l  FXsy[Wő吔
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CIniInfo::loadOptionAreaMax( void )
{
	if ( m_iAreaMax == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "AreaMax", EXEC_SPIN_DEF, cProfile );

		m_iAreaMax = atoi(cProfile);
	}

	return( m_iAreaMax );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionAreaMax
//\bhFXsy[Wő吔̕ۑ
//`    F  void saveOptionAreaMax(
//@@@@@@@F    [in]  int iVal F Xsy[Wő吔
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIniInfo::saveOptionAreaMax( int iVal )
{
	if ( iVal == loadOptionAreaMax() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "AreaMax", (long)iVal );

	m_iAreaMax = iVal;

	return;
}

int CIniInfo::loadOptionLaunchMenu( void )
{
	if ( m_iLaunchMenu == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "LaunchMenu", "1", cProfile );

		m_iLaunchMenu = atoi(cProfile);
	}

	return( m_iLaunchMenu );
}

void CIniInfo::saveOptionLaunchMenu( int iVal )
{
	if ( iVal == loadOptionLaunchMenu() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "LaunchMenu", (long)iVal );

	m_iLaunchMenu = iVal;

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionExecDlgX
//\bhFE`_CAO\ʒuXW̕ۑ
//`    F  void saveOptionExecDlgX(
//@@@@@@@F    [in]  long lVal F E`_CAO\ʒuXW
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIniInfo::saveOptionExecDlgX( long lVal )
{
	if ( lVal == loadOptionExecDlgX() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "ExecDlgX", lVal );

	m_lExecDlgX = lVal;

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionExecDlgY
//\bhFE`_CAO\ʒuYW̕ۑ
//`    F  void saveOptionExecDlgY(
//@@@@@@@F    [in]  long lVal F E`_CAO\ʒuYW
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CIniInfo::saveOptionExecDlgY( long lVal )
{
	if ( lVal == loadOptionExecDlgY() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "ExecDlgY", lVal );

	m_lExecDlgY = lVal;

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionExecDlgX
//\bhFE`_CAO\ʒuXW̓Ǎ
//`    F  long loadOptionExecDlgX(
//              F  )
//^[l  FE`_CAO\ʒuXW
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
long CIniInfo::loadOptionExecDlgX( void )
{
	if ( m_lExecDlgX == -1000 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "ExecDlgX", "400", cProfile );

		m_lExecDlgX = atol(cProfile);
	}

	return( m_lExecDlgX );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionExecDlgY
//\bhFE`_CAO\ʒuYW̓Ǎ
//`    F  long loadOptionExecDlgY(
//              F  )
//^[l  FE`_CAO\ʒuYW
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
long CIniInfo::loadOptionExecDlgY( void )
{
	if ( m_lExecDlgY == -1000 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "ExecDlgY", "50", cProfile );

		m_lExecDlgY = atol(cProfile);
	}

	return( m_lExecDlgY );
}

void CIniInfo::loadPageName( int iPageNo, char* pcPageName )
{
	if ( pcPageName == NULL ) {
		return;
	}

	if ( m_pcsPageName[iPageNo-1] == NULL ) {
		char cProfile[256];
		CString csTemp;
		CString csDef;

		//Iniݒ擾
		csTemp.Format( "PageName%d", iPageNo );
		csDef.Format( "߰%3d", iPageNo );
		loadOptionCommon( "PAGE", csTemp.GetBuffer(csTemp.GetLength()), csDef.GetBuffer(csDef.GetLength()), cProfile );
		csTemp.ReleaseBuffer();
		csDef.ReleaseBuffer();

		strcpy( pcPageName, cProfile );

		m_pcsPageName[iPageNo-1] = new CString;
		if ( m_pcsPageName[iPageNo-1] != NULL ) {
			*(m_pcsPageName[iPageNo-1]) = pcPageName;
		}
	}
	else {
		strcpy( pcPageName, (m_pcsPageName[iPageNo-1])->GetBuffer((m_pcsPageName[iPageNo-1])->GetLength()) );
		(m_pcsPageName[iPageNo-1])->ReleaseBuffer();
	}

	return;
}

void CIniInfo::savePageName( int iPageNo, char* pcPageName )
{
	char cIniFileName[512];
	CString csTemp;

	if ( pcPageName == NULL ) {
		return;
	}

	//Iniݒ擾
	getIniFileName( cIniFileName );
	csTemp.Format( "PageName%d", iPageNo );
	::WritePrivateProfileString( "PAGE", csTemp.GetBuffer(csTemp.GetLength()), pcPageName, cIniFileName );
	csTemp.ReleaseBuffer();

	if ( m_pcsPageName[iPageNo-1] == NULL ) {
		m_pcsPageName[iPageNo-1] = new CString;
	}
	*(m_pcsPageName[iPageNo-1]) = pcPageName;

	return;
}

int CIniInfo::loadButtonTitle( int iButtonIndex, int iSpinIndex, char* pcTitle )
{
	int iRet = 0;
	CString CSectionName;
	char cTemp[EXEC_TEMP_MAX];
	CString csSpin;
	CString* pcsTemp;

	if ( pcTitle == NULL ) {
		return( -1 );
	}

	if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
		return( -1 );
	}

	if ( iSpinIndex > EXEC_PAGE_MAX ) {
		return( -1 );
	}

	if ( m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == NULL ) {
		TRY {
			//{^ɑΉZNV̎擾
			iRet = GetSectionName( iButtonIndex, &CSectionName );
			if ( iRet < 0 ) {
				return( -1 ) ;
			}

			csSpin.Format( "%d", iSpinIndex );
			CSectionName += csSpin;

			//t@C̎擾
			iRet = loadOptionCommon( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_TITLE, "", cTemp );
			CSectionName.ReleaseBuffer();

			if ( iRet == 0 ) {
				m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = new CString;
				pcsTemp = m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
				*pcsTemp = cTemp;
			}
			else {
				m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = (CString*)(NULL + 1);
			}
		}
		CATCH( CMemoryException, e ) {
			iRet = -1;
		} END_CATCH
	}
	else if ( m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == (CString*)(NULL + 1) ) {
		iRet = -1;
	}
	else {
		iRet = 0;
	}

	if ( iRet == 0 ) {
		pcsTemp = m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
		strcpy( pcTitle, pcsTemp->GetBuffer(pcsTemp->GetLength()) );
		pcsTemp->ReleaseBuffer();
	}
	else {
		strcpy( pcTitle, "" );
	}

	return( iRet );

}

int CIniInfo::saveButtonTitle( int iButtonIndex, int iSpinIndex, char* pcTitle )
{
	int iRet = 0;
	CString CSectionName;
	char cIniFileName[512];
	CString csSpin;
	CString* pcsTemp;

	TRY {
		if ( pcTitle == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		getIniFileName( cIniFileName );

		//^Cg̕ۑ
		::WritePrivateProfileString( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_TITLE, pcTitle, cIniFileName );
		CSectionName.ReleaseBuffer();

		if ( strlen(pcTitle) > 0 ) {
			if ( m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == NULL ||
				 m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == (CString*)(NULL + 1) ) {
				m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = new CString;
			}
			pcsTemp = m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
			*pcsTemp = pcTitle;
		}
		else {
			if ( m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == NULL ||
				 m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] == (CString*)(NULL + 1) ) {
				m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = (CString*)(NULL + 1);
			}
			else {
				//mۂĂ̈
				delete m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex];
				m_pcsTitle[iSpinIndex*EXEC_BUTTON_MAX+iButtonIndex] = (CString*)(NULL + 1);
			}
		}

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

int CIniInfo::loadOptionDragRun( void )
{
	if ( m_iDragRun == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "DragRun", "0", cProfile );

		m_iDragRun = atoi(cProfile);
	}

	return( m_iDragRun );
}

void CIniInfo::saveOptionDragRun( int iVal )
{
	if ( iVal == loadOptionDragRun() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "DragRun", (long)iVal );

	m_iDragRun = iVal;

	return;
}

int CIniInfo::loadOptionSearchMode( void )
{
	if ( m_iSearchMode == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "SearchMode", "0", cProfile );

		m_iSearchMode = atoi(cProfile);
	}

	return( m_iSearchMode );
}

void CIniInfo::saveOptionSearchMode( int iVal )
{
	if ( iVal == loadOptionSearchMode() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SearchMode", (long)iVal );

	m_iSearchMode = iVal;

	return;
}

int CIniInfo::loadOptionDispOvw( void )
{
	if ( m_iDispOvw == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "DispOvw", "0", cProfile );

		m_iDispOvw = atoi(cProfile);
	}

	return( m_iDispOvw );
}

void CIniInfo::saveOptionDispOvw( int iVal )
{
	if ( iVal == loadOptionDispOvw() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "DispOvw", (long)iVal );

	m_iDispOvw = iVal;

	return;
}

int CIniInfo::loadOptionDispTool( void )
{
	if ( m_iDispTool == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "DispTool", "0", cProfile );

		m_iDispTool = atoi(cProfile);
	}

	return( m_iDispTool );
}

void CIniInfo::saveOptionDispTool( int iVal )
{
	if ( iVal == loadOptionDispTool() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "DispTool", (long)iVal );

	m_iDispTool = iVal;

	return;
}

int CIniInfo::loadOptionTransparent( void )
{
	if ( m_iTransparent == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "Transparent", "0", cProfile );

		m_iTransparent = atoi(cProfile);
	}

	return( m_iTransparent );
}

void CIniInfo::saveOptionTransparent( int iVal )
{
	if ( iVal == loadOptionTransparent() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "Transparent", (long)iVal );

	m_iTransparent = iVal;

	return;
}

int CIniInfo::loadOptionExecDlgSmall( void )
{
	if ( m_iExecDlgSmall == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "ExecDlgSmall", "1", cProfile );

		m_iExecDlgSmall = atoi(cProfile);
	}

	return( m_iExecDlgSmall );
}

void CIniInfo::saveOptionExecDlgSmall( int iVal )
{
	if ( iVal == loadOptionExecDlgSmall() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "ExecDlgSmall", (long)iVal );

	m_iExecDlgSmall = iVal;

	return;
}

int CIniInfo::loadOptionExecDlgSmallIconSize( void )
{
	if ( m_iExecDlgSmallIconSize == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "ExecDlgSmallIconSize", "24", cProfile );

		m_iExecDlgSmallIconSize = atoi(cProfile);
	}

	return( m_iExecDlgSmallIconSize );
}

void CIniInfo::saveOptionExecDlgSmallIconSize( int iVal )
{
	if ( iVal == loadOptionExecDlgSmallIconSize() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "ExecDlgSmallIconSize", (long)iVal );

	m_iExecDlgSmallIconSize = iVal;

	return;
}

int CIniInfo::loadOptionSingleClickDlg(void )
{
	if ( m_iSingleClickDlg == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "SingleClickDlg", "0", cProfile );

		m_iSingleClickDlg = atoi(cProfile);
	}

	return( m_iSingleClickDlg );
}

void CIniInfo::saveOptionSingleClickDlg( int iVal )
{
	if ( iVal == loadOptionSingleClickDlg() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SingleClickDlg", (long)iVal );

	m_iSingleClickDlg = iVal;

	return;
}

int CIniInfo::loadOptionTopMost( void )
{
	if ( m_iTopMost == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "TopMost", "0", cProfile );

		m_iTopMost = atoi(cProfile);
	}

	return( m_iTopMost );
}

void CIniInfo::saveOptionTopMost( int iVal )
{
	if ( iVal == loadOptionTopMost() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "TopMost", (long)iVal );

	m_iTopMost = iVal;

	return;
}

int CIniInfo::loadOptionNoAnime( void )
{
	if ( m_iNoAnime == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "NoAnime", "0", cProfile );

		m_iNoAnime = atoi(cProfile);
	}

	return( m_iNoAnime );
}

void CIniInfo::saveOptionNoAnime( int iVal )
{
	if ( iVal == loadOptionNoAnime() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "NoAnime", (long)iVal );

	m_iNoAnime = iVal;

	return;
}

int CIniInfo::loadOptionFocusIcon( void )
{
	if ( m_iFocusIcon == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "FocusIcon", "1", cProfile );

		m_iFocusIcon = atoi(cProfile);
	}

	return( m_iFocusIcon );
}

void CIniInfo::saveOptionFocusIcon( int iVal )
{
	if ( iVal == loadOptionFocusIcon() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "FocusIcon", (long)iVal );

	m_iFocusIcon = iVal;

	return;
}

int CIniInfo::loadOptionFlatIcon( void )
{
	if ( m_iFlatIcon == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "FlatIcon", "0", cProfile );

		m_iFlatIcon = atoi(cProfile);
	}

	return( m_iFlatIcon );
}

void CIniInfo::saveOptionFlatIcon( int iVal )
{
	if ( iVal == loadOptionFlatIcon() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "FlatIcon", (long)iVal );

	m_iFlatIcon = iVal;

	return;
}

int CIniInfo::loadOptionCacheIcon( void )
{
	if ( m_iPreIcon == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "CacheIcon", "1", cProfile );

		m_iPreIcon = atoi(cProfile);
	}

	return( m_iPreIcon );
}

void CIniInfo::saveOptionCacheIcon( int iVal )
{
	if ( iVal == loadOptionCacheIcon() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "CacheIcon", (long)iVal );

	m_iPreIcon = iVal;

	return;
}

int CIniInfo::loadOptionBigIcon( void )
{
	if ( m_iBigIcon == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "BigIcon", "1", cProfile );

		m_iBigIcon = atoi(cProfile);
	}

	return( m_iBigIcon );
}

void CIniInfo::saveOptionBigIcon( int iVal )
{
	if ( iVal == loadOptionBigIcon() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "BigIcon", (long)iVal );

	m_iBigIcon = iVal;

	return;
}

int CIniInfo::loadOptionSearchRun( void )
{
	if ( m_iSearchRun == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "SearchRun", "1", cProfile );

		m_iSearchRun = atoi(cProfile);
	}

	return( m_iSearchRun );
}

void CIniInfo::saveOptionSearchRun( int iVal )
{
	if ( iVal == loadOptionSearchRun() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SearchRun", (long)iVal );

	m_iSearchRun = iVal;

	return;
}

int CIniInfo::loadOptionCustomButton( void )
{
	if ( m_iCustomButton == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "CustomButton", "0", cProfile );

		m_iCustomButton = atoi(cProfile);
	}

	return( m_iCustomButton );
}

void CIniInfo::saveOptionCustomButton( int iVal )
{
	if ( iVal == loadOptionCustomButton() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "CustomButton", (long)iVal );

	m_iCustomButton = iVal;

	return;
}
void CIniInfo::loadOptionCBPathName( char* pcPathName )
{
	if ( pcPathName == NULL ) {
		return;
	}

	if ( m_pcsCBPathName == NULL ) {
		char cProfile[256];
		CString csTemp;
		CString csDef;

		m_pcsCBPathName = new CString;

		//Iniݒ擾
		loadOptionCommon( "OPTION", "CustomButtonPath", "Button", cProfile );
		*m_pcsCBPathName = cProfile;
		strcpy( pcPathName, cProfile );
	}
	else {
		strcpy( pcPathName, m_pcsCBPathName->GetBuffer(m_pcsCBPathName->GetLength()) );
		m_pcsCBPathName->ReleaseBuffer();
	}

	return;
}

void CIniInfo::saveOptionCBPathName( char* pcPathName )
{
	char cIniFileName[512];

	if ( m_pcsCBPathName == NULL ) {
		m_pcsCBPathName = new CString;
	}

	getIniFileName( cIniFileName );
	::WritePrivateProfileString( "OPTION", "CustomButtonPath", pcPathName, cIniFileName );
	*m_pcsCBPathName = pcPathName;

	return;
}

int CIniInfo::loadOptionDlgVertical( void )
{
	if ( m_iDlgVertical == -1 ) {
		char cProfile[256];

		//Iniݒ擾
		loadOptionCommon( "OPTION", "DlgVertical", "0", cProfile );

		m_iDlgVertical = atoi(cProfile);
	}

	return( m_iDlgVertical );
}

void CIniInfo::saveOptionDlgVertical( int iVal )
{
	if ( iVal == loadOptionDlgVertical() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "DlgVertical", (long)iVal );

	m_iDlgVertical = iVal;

	return;
}
